<?php

/**
 * OntoWiki - wiki controller class
 *
 * @author AKSW team
 * @version $Id: WikiController.php 2572 2008-09-29 16:20:29Z fusel2k $
 */
class WikiController extends OntoWiki_Controller_Action {

	/**
	 * @var string default group
	 */
	protected $_defaultGroupUri = 'http://localhost/OntoWiki/Config/DefaultUserGroup';

	/**
	 * Initialisation method.
	 */
	public function init() {
		parent::init();
		$this->_session = Zend_Registry::get('session');
		$this->model = Zend_Registry::get('config')->activeModel;
	}


	/**
	 * perform login action
	 * TODO: move auth to Action.php for global auth possebility
	 * TODO: forward to last site
	 */
	public function loginAction() {
		$this->log->debug('WikiController::loginAction()');

		$post = Zend_Registry::get('post');

		$redirect = urldecode($post['redirect']);

		$username = '';
		$password = '';
		if (isset($post['username']) and isset($post['password'])) {
				
			$username = $post['username'];
			$password = $post['password'];
				
//			if (Zend_Uri_Http::check($username)) {
//				$consumer = new Zend_OpenId_Consumer();
//				$consumer->login($username,
//				$this->config->uriBase . 'wiki/login/method/openid/',
//				$this->config->ServerProtocol . $_SERVER['HTTP_HOST'] . $this->config->uriBase
//				);
//			} else {
//				$username = Zend_Filter_Alnum::filter($post['username']);
//			}
		}
//		if (isset($_GET['openid_mode']) && $_GET['openid_mode'] == 'id_res') {
//			$consumer = new Zend_OpenId_Consumer();
//			$id = '';
//			foreach ($_GET as $key => $value) {
//				if (strstr($key,'openid_')) {
//					$openid_param[$key] = $value;
//				}
//			}
//			if ($x = $consumer->verify($openid_param,$id)) {
//				var_dump($id);exit();
//			}
//		}
		$result = Zend_Registry::get('erfurt')->authenticate($username, $password);
		
		// If remember option is on make session persistent
		if (!empty($post['rememberme']) && $post['rememberme'] == 'on') {
			// Make session persistent (for about 23 years)
			Zend_Session::rememberMe(726364800);
		}
		
		if ($result->isValid()) {
			// Authentication success; save the reasons why for authbox
		}

		Zend_Registry::set('authResult', $result);
		$this->_session->authResult = $result->getMessages();

		// test whether user has at least one model
		if ($result->isValid() && count($this->erfurtApp->getStore()->listModels(true)) === 0) {
			Zend_Auth::getInstance()->clearIdentity();
			Zend_Session::namespaceUnset(('OW' . Zend_Registry::get('sessionNsId')));
			Zend_Session::namespaceUnset(('ERFURT' . Zend_Registry::get('sessionNsId')));

			$this->_session->authResult = array('No available model found... so you were automatically logged out.');

			//throw new Exception('No available model found... so you are automatically logged out.');
		}
		
		$this->ed->trigger('onLogin', &$redirect);
		$this->_redirect($redirect);
	}


	/**
	 * logout action
	 * TODO: forward richtig setzen
	 */
	public function logoutAction() {
		$this->log->debug('WikiController::logoutAction()');

		Zend_Auth::getInstance()->clearIdentity();
		Zend_Session::namespaceUnset(('OW' . Zend_Registry::get('sessionNsId')));
		Zend_Session::namespaceUnset(('ERFURT' . Zend_Registry::get('sessionNsId')));
		Zend_Session::ForgetMe();

		//session_destroy();
		$this->_redirect('');
	}

	/**
	 * user registration action
	 */
	public function registernewAction() {

		$this->log->debug('WikiController::registerNewAction()');

		$this->_helper->viewRenderer->setScriptAction('register');

		$post = Zend_Registry::get('post');

		$authAdapter = $this->erfurtApp->getAuthAdapter();
		$errors = array();
		$messages = array();

		// empty registration
		if (!isset($post['submit'])) {
			$this->view->title     = 'Register New User';
			$this->view->actionUrl = $this->config->uriBase . 'wiki/registerNew/';

			return false;
		}

		try {
			if ($authAdapter->addUser($post['username'], $post['email'], $post['password'], $post['password2'])) {
				$messages[] = 'The user "' . $post['username'] . '" has been successfully registered.';
				$this->view->removeForm = true;
			} else {
				// nothing to do
			}
		} catch (Erfurt_Exception $ee) {
			$errors[] = $ee->getMessage();
		}

		$this->view->username = $post['username'];
		$this->view->email    = $post['email'];

		# auth adapter reload
		$authAdapter->fetchUserData();

		$this->view->title    = 'Register New User';
		$this->view->errors   = $errors;
		$this->view->messages = $messages;
	}

	/**
	 * user registration action
	 */
	public function registereditAction() {
		$this->log->debug('WikiController::registerAction()');

		$this->_helper->viewRenderer->setScriptAction('register');

		$identity   = Zend_Auth::getInstance()->getIdentity();
		$post       = Zend_Registry::get('post');

		$authAdapter = $this->erfurtApp->getAuthAdapter();
		$userList = $authAdapter->listUsers();

		$userNames = array();
		$userEmails = array();

		foreach ($userList as $uUri => $uF) {
			$userNames[] = $uF['userName'];
			$userEmails[] = str_replace('mailto:', '', $uF['userEmail']);
		}

		$errors = array();
		$messages = array();

		# change reg-data
		if ($identity['anonymous'] === true) {
			$this->_redirect('/wiki/registerNew');
		}

		// Identity exists; get it
		$this->view->username      = $identity['username'];
		$this->view->email         = str_replace('mailto:', '', $identity['email']);
		$this->view->fixedUserName = true;
		$this->view->title         = 'Change Registration Data';

		# empty registration
		if (!isset($post['submit'])) {
			$this->view->title     = 'Change Registration Data';
			$this->view->actionUrl = $this->config->uriBase . 'wiki/registerEdit/';

			return;
		}

		$vE = new Zend_Validate_EmailAddress();

		# process submit
		if(!$this->erfurtApp->getAcModel()->modelURI
		|| !($res = $this->erfurtApp->getAcModel()->resourceF($identity['uri']))
		|| !($actionConfig = $this->erfurtApp->getAc()->getActionConfig('RegisterNewUser'))) {
			$errors[] = 'Error in loading user instance.';
		} else {
			# password
			if ($post['password'] != '' and $post['password2'] != '') {
				if($post['password'] != $post['password2']) {
					$errors[] = 'Passwords do not match.';
				} elseif (strlen($post['password']) < 5) {
					$errors[] = 'Password needs at least 5 characters.';
				} else {
					# change user password
					$res->removePropertyValues($this->config->ac->user->pass);
					$this->erfurtApp->getAcModel()->add($identity['uri'], $this->config->ac->user->pass, new Literal(sha1($post['password'])));
					$messages[] = 'Password changed.';
				}
			}
			// normalize e-mail
			$post['email']     = str_replace('mailto:', '', $post['email']);
			$identity['email'] = str_replace('mailto:', '', $identity['email']);

			# email
			if ($post['email'] != $identity['email']) {
				if (isset($actionConfig['mailvalidation']) and $actionConfig['mailvalidation'] == 'yes' and !$vE->isValid($post['email'])) {
					$errors[] = 'E-mail address is incorrect.';
				} else if(trim($post['email']) == '') {
					$errors[] = 'E-mail address must not be empty.';
				} else if(in_array($post['email'], $userEmails)) {
					$errors[] = 'E-mail address already registered.';
				} else {
					# email correct
					$res->removePropertyValues($this->config->ac->user->mail);
					$this->erfurtApp->getAcModel()->add(new Statement(new Resource($identity['uri']),
					new Resource($this->config->ac->user->mail),
					new Resource('mailto:' . $post['email'])));

					#$instance->setPropertyValue($this->config->ac->user->mail, $post['email']);
					$messages[] = 'E-Mail address changed.';
					$this->view->email = $post['email'];
					$identity['email'] = $post['email'];
					$storage = Zend_Auth::getInstance()->getStorage();
					$storage->write($identity);
				}
			}
		}

		# auth adapter reload
		$authAdapter->fetchUserData();

		// TODO: eval form

		$this->view->title    = 'Change Registration Data';
		$this->view->errors   = $errors;
		$this->view->messages = $messages;
	}

	/**
	 * search form box action
	 */
	public function searchAction() {
		$this->log->debug('WikiController::searchAction()');

		if ($this->config->activeModel == null) {
			$allModels = true;
		} else {
			$allModels = ($this->_request->getParam('allModels', '') == 'on') ? true : false;
		}

		$model     = $allModels ? $this->_session->activeModelUri : $this->erfurtStore->getModel($this->_request->getParam('m'));
		$search    = $this->_request->getParam('s');
		$results   = array();

		$is = new InstanceSearch($model, $search, array(), array(), $this->erfurtStore);
		if ($allModels) {
			$is->allModels = $allModels;
		}

		// TODO: classes and properties filter

		$start = isset($this->_request->start) ? $this->_request->start : 0;
		$count = isset($this->_request->count) ? $this->_request->count : 10;

		// $select = new SelectNew(array('cardinality' => 1, 'onchange' => 'this.form.submit()'));

		// perform search
		if ($rs = $is->search($start, $count, &$erg)) {
			foreach ($rs->getArray() as $num => $row) {
				if (!$m = /* $this->model ? $this->model :*/ $this->erfurtStore->getModel($row[8])) {
					$erg--;
					continue;
				}
				$stm = $m->_convertRowToStatement($row);
				$type = $stm->subj->getType();
				if (!$max_rel) {
					$max_rel = $row[9];
				}

				if ($allModels) {
					$result['url']       = OntoWiki_Util::getURLabsolute($stm->subj, $m);
				} else {
					$result['url']       = OntoWiki_Util::getURL($stm->subj, $m);
				}

				$result['title']     = $stm->subj->getTitle($this->_session->modelLanguage);
				$result['type']      = $type->getTitle($this->_session->modelLanguage);
				$result['relevance'] = ($max_rel ? round(100 * $row[9] / $max_rel) . '%' : '');
				$result['property']  = $stm->pred->getTitle($this->_session->modelLanguage);
				$result['value']     = OntoWiki_Util::highlightText($stm->obj->getLabel(), $search);

				$results[] = $result;
			}
		}

		$this->view->start     = $start;
		$this->view->results   = $results;
		// $this->view->assign('searchText', $search);
		// $this->view->assign('selectWidget', $select);

		$this->view->title   = $this->strings->wiki->search->title;

		$countScript = '<a href="javascript:setCount(' . $this->session->count . ')">' . $this->session->count . '</a>';

		if ($erg > $this->_session->count) {
			$statusTools[] = 'Pages:&nbsp;' . $this->view->makeList(OntoWiki_Util::getPagerHtml($start, $this->session->count, $erg), 'ul', 'minibutton');
			$statusLines[] = 'Showing ' . $countScript . ' of ' . $erg . ' results per page.';
		} else {
			if ($erg > 1) {
				$statusLines[] = 'Search returned ' . $erg . ' results (showing ' . $countScript . '  per page).';
			} elseif ($erg == 1) {
				$statusLines[] = 'Search returned 1 result.';
			} else {
				$statusLines[] = 'No results found.';
			}
		}

		$this->view->statusTools = $statusTools;
		$this->view->statusLines = $statusLines;
	}

	/**
	 * removes all sbac views
	 */
	public function dropsbacAction() {
		$this->log->debug('WikiController::dropsbacAction()');
		$windowView = $this->view->getSubView();
		$subView    = $windowView->getSubView();
		$identity = Zend_Auth::getInstance()->getIdentity();

		$authAdapter = $this->erfurtApp->getAuthAdapter();

		$messages = array();
		$errors = array();

		if (($sbacObj = $this->erfurtApp->getAc()->getSbac()) != null) {
			if ($sbacObj->dropSbac()) {
				$messages[] = 'Statementbased access control has been successfully reseted';
			} else {
				$errors[] = 'Can\'t remove statementbased access control ';
			}
			$GLOBALS['RAP']['conf']['database']['tblStatements'] = 'statements';
		} else {
			$errors[] = 'No statementbased access control available';
		}



		$windowView->title    = 'Statementbased access control';
		$windowView->content  = '';
		$windowView->errors   = $errors;
		$windowView->messages = $messages;

		$this->view->mainWindows = array($windowView->render('micro/window.php'));
	}

	/**
	 * creates sbac view
	 */
	public function generatesbacAction() {

	}

	/**
	 *  Recoverpassword Action
	 *  Manages Password Recovery for Users
	 */
	public function recoverpasswordAction() {
		$this->log->debug('WikiController::recoverPasswordAction()');

		$options = $this->_request->getParams();
		$aad = $this->erfurtApp->getAuthAdapter();
			
		$this->view->uriBase = $this->config->uriBase;

		try {

			if ( $options['step'] == 1 ) {
				$this->view->step = $options['step'];
				if ($options['username_only'] == 1 && $aad->sendUsername($options['username_rc']) ) {
					$this->view->messages = array( $this->strings->auth->pwrecovery->success1);
				} else if ( $aad->sendResetLink($options['username_rc'] ) ) {
					$this->view->messages = array( $this->strings->auth->pwrecovery->success1 );
				} else {
					$this->view->errors = array( $this->strings->auth->pwrecovery->error1 );
				}
			} else if ($options['step'] == 2) {
				$this->view->step = $options['step'];
				if ( $aad->checkResetLink($options['hash']) ) {
					$this -> view -> hash = $options['hash'];
					// Alles i.O.
				} else {
					$this->view->errors = array( $this->strings->auth->pwrecovery->error2 );
				}
			} else if ($options['step'] == 3) {
				$this->view->step = $options['step'];
				if ( $aad->setPasswordOnHash($options['password_new_1'], $options['password_new_2'], $options['hash']) ) {
					$this->view->messages = array( $this->strings->auth->pwrecovery->success2 );
				} else {
					$this->view->ignoreErrors = true;
					$this->view->step = 2;
					$this->view->errors = array( $this->strings->auth->pwrecovery->error3 );
				}
			} else {
				$this->view->step = 0;
			}

		} catch (Erfurt_Exception $ee) {
			$this->view->step = 0;
			$this->view->errors = array( $ee->getMessage() );
		}

	}

	/**
	 *  	For undefined controller actions.
	 */

	/**
	 * Catch action
	 *
	 * Will be called when an undefined action is called
	 */
	public function __call($methodName, $args) {
		$this->log->debug('WikiController::__call()');
		$this->_redirect('');
	}

}
