<?php
/**
 * OntoWiki bootstrap file
 * 
 * @author AKSW team
 * @version $Id$
 */

/**
 * Load settings file to setup system
 */
require_once 'app/config/settings.php';

/**
 * Get instance of Zend_Controller_Front, set router
 * and controller directory and start dispatching
 */
$front = Zend_Controller_Front::getInstance();
$front->setRouter($router);
$front->setBaseUrl($config->basepath);
$front->setControllerDirectory(REAL_BASE . 'app/controllers');
$front->returnResponse(true);

if (defined('_OWDEBUG')) {
    $front->throwExceptions(true);
} else {
    $front->throwExceptions(false);
}

// instantiate and register controller plug-ins
$front->registerPlugin(new OntoWiki_Controller_Plugin_HttpAuth());
$front->registerPlugin(new OntoWiki_Controller_Plugin_PreFetch());
$front->registerPlugin(new OntoWiki_Controller_Plugin_ResourceToFile());

# prepare environment for plugins
if (isset($erfurt) && isset($config) && $erfurt && $config) {

    # read plugins
	if ($config->plugins->ontowiki && strlen($config->plugins->ontowiki)>0) {
	    $tempPm = $erfurt->getPluginManager();
		$tempPm->init(REAL_BASE . $config->plugins->ontowiki);
		unset($tempPm);
	}
	# maybe add additional plugin folders
    # ...

    # automatic event triggers (except preDispatch and postDispatch)
    $front->registerPlugin(new OntoWiki_Controller_Plugin_TriggerZendEventMethods($erfurt->getEventDispatcher()));

    # helper for automatic event triggers (preDispatch and postDispatch)
    $triggerZendEventMethods = new OntoWiki_Controller_Helper_TriggerZendEventMethods($erfurt->getEventDispatcher());
    Zend_Controller_Action_HelperBroker::addHelper($triggerZendEventMethods);
}


/**
 * Dispatch the Request and send the Response
 */

// Redirect to Service for Plugins.

$ow_folder=substr($_SERVER["PHP_SELF"],0,-8);
$ow_doc = substr($_SERVER['SCRIPT_FILENAME'],0,-8);
$ow_ini = parse_ini_file($ow_doc."config.ini");

if (($ow_ini['lod.models']!="")and($ow_ini['lod.modelclass']!="")) {

	$ow_action=substr($_SERVER["REQUEST_URI"],0,strpos($_SERVER["REQUEST_URI"],"/",strlen($ow_folder))+1);


	// Linked Open Data Modell
	if (($ow_action!="")and($ow_action!="/")and($ow_action[strlen($ow_action)-1]=="/")) {
		if (strpos("/".$ow_ini['lod.models'],$ow_action)>0) {
			// later add some information to export rdf $_SERVER["HTTP_ACCEPT"] 
			$ow_redirect="Location: http://".$_SERVER['HTTP_HOST'].$ow_folder."resource/list/?r=".$ow_ini['lod.modelclass']."&m=http://".$_SERVER['HTTP_HOST'].$ow_folder.substr($_SERVER["REQUEST_URI"],1);
			//echo $ow_redirect;
			header($ow_redirect);
			exit;
		}

	}

};
if ($ow_folder==$_SERVER['REQUEST_URI']) {


	if ($ow_ini['start.plugin']!="") {

		$pi_ini = parse_ini_file($ow_doc."plugins/".$ow_ini['start.plugin']."/config.ini");

		if ($pi_ini['switch']==$ow_ini['start.switch']) {
			// Redirect to Service depending on switched on/of Plugin
			header("Location: ".$ow_ini['start.redirect']);
			exit;
		}
	} else {
		if ($ow_ini['start.redirect']!="") {
			// Redirect allways if no Plugin defined
			header("Location: ".$ow_ini['start.redirect']);
			exit;
		}

	}
}

# try to use zf or 404 error
try {
	$response = $front->dispatch();
	// $response = $front->getResponse();
	#printr($response);
	$response->sendResponse();

} catch (Exception $e) {


	# simple 404 handling
	# ToDo: do it the zend way: http://framework.zend.com/wiki/display/ZFDEV/5.+Dispatch+Error+Handling+and+404+Error+Pages
	header('HTTP/1.0 404 Not Found');
	renderError(
		'Page Not Found', 
		'404 Not Found (<a href="' . $config->uriBase . '">go to OntoWiki</a>)' . '<br />' . get_class($e) . ': ' . $e->getMessage()
	);
}
#printr(get_included_files());
?>
