<?php
/**
 * OpenID Authentication Class based upon Zend_Auth_Adapter_OpenId, 
 * only has some extensions to the identity
 * 
 * @package auth
 */
class Erfurt_Auth_Adapter_Openid extends Zend_Auth_Adapter_OpenId {

	/**
	 * Method to do auth via openid
	 * 
	 * @param string openid_identifier (Openid URI)
	 * @return instance of Zend_Auth_Result
	 */
	public function authenticate($openid_identifier = null) {
		Zend_Registry::get('erfurtLog')->debug('Erfurt_Auth_Adapter_OpenId::authenticate()');
		
		// call method of superclass
		$result = parent::authenticate($openid_identifier);
		
		// if result is valid and the Openid Credentials in $_GET then set new identity
		if ( $result->isValid() && isset($_GET['openid_identity']) ) {
			$identity = array(
			        'username' => 'OpenIdUser',
	                'uri'	=>	'http://localhost/OntoWiki/Config/OpenIdUser',
	                'dbuser'	=>	false,
	                'anonymous' => false,
			        'openid' => $_GET['openid_identity']
			);
			return new Zend_Auth_Result(true,$identity,array());
		} else {
			// return result of super class
			return $result;
		}
	}
	
}
?>