<?php

/**
  * Trigger Zend event methods automatically
  *
  * @author Michael Haschke
  * @version $Id$
  * @package OntoWiki
  * @subpackage	Controller
  */
class OntoWiki_Controller_Helper_TriggerZendEventMethods extends Zend_Controller_Action_Helper_Abstract {
	
    private $_ed = null;
    public $request = null;

    function __construct(Erfurt_EventDispatcher $ed) {
        $this->_ed = $ed;
    }

    public function preDispatch()
    {
        /*
        
        done in controller plugin
        
        $controller = Zend_Controller_Front::getInstance();
        $this->request = $controller->getRequest();
        $request = $this->request;
        $this->_ed->trigger('ZendPreDispatch',$this);
        $this->_ed->trigger($request->getModuleName().'_'.$request->getControllerName().'_'.$request->getActionName().'_ZendPreDispatch',$this);

        */

        // test for ViewRenderer helper and put them after this helper in the helper stack
        // this is important for ZendPostDispatch events because otherwise the view will be rendered before plugins can manipulate it while ZendPostDispatch
        if (Zend_Controller_Action_HelperBroker::hasHelper('ViewRenderer')) {
            $helperStackOrder = array_keys(Zend_Controller_Action_HelperBroker::getExistingHelpers());
            if (array_search('ViewRenderer', $helperStackOrder) < array_search('TriggerZendEventMethods', $helperStackOrder)) {
                $vr = Zend_Controller_Action_HelperBroker::getExistingHelper('ViewRenderer');
                if (Zend_Controller_Action_HelperBroker::removeHelper('ViewRenderer'))
                    Zend_Controller_Action_HelperBroker::addHelper($vr);
                unset($vr);
            }
        }
    }

    public function postDispatch()
    {
        
        $controller = Zend_Controller_Front::getInstance();
        $this->request = $controller->getRequest();
        $request = $this->request;
        $this->_ed->trigger('ZendPostDispatch',$this);
        $this->_ed->trigger($request->getModuleName().'_'.$request->getControllerName().'_'.$request->getActionName().'_ZendPostDispatch',$this);
    }

}

?>
