<?php

/**
  * Tries to fetch a model from URI parameters. This plug-in must be
  * executed after the HttpAuth plug-in.
  *
  * @author Norman Heino <norman.heino@googlemail.com>
  * @version $Id$
  * @package OntoWiki
  * @subpackage	Controller
  */
class OntoWiki_Controller_Plugin_PreFetch extends Zend_Controller_Plugin_Abstract {
	
	/**
	  * Overwrite preDispatch to get informed before any dispatching occurs.
	  */
	public function preDispatch(Zend_Controller_Request_Abstract $request) {
		$session = Zend_Registry::get('session');
		$config  = Zend_Registry::get('config');
		$erfurt  = Zend_Registry::get('erfurt');
		$logger  = Zend_Registry::get('owLog');
		
		// try m parameter
		if (isset($request->m) && $erfurt->getAc()->isModelAllowed('view', $request->m)) {
			$session->activeModelUri = $request->m;
		// try deprecated model parameter
		} elseif (isset($request->model) && $erfurt->getAc()->isModelAllowed('view', $request->model)) {
			$session->activeModelUri = $request->model;
		}
		
		if (!empty($session->activeModelUri)) {
			$logger->debug('Model set: ' . $session->activeModelUri);
			
			// TODO: do we still need this?
			#$_SESSION['_ETS']['model'] = $session->activeModelUri;
			#$_ET['rdfsmodel'] = 
			$model = $erfurt->getStore()->getModel($session->activeModelUri);
		}

		$config->activeModel = $model;
		
		// fetch resource
		if (isset($request->r) && is_object($model)) {
			$config->activeResource = $model->resourceF($request->r, true);
			$session->activeResourceUri = $config->activeResource->getURI();
		}
	}
}

?>
