<?php

/**
  * OntoWiki current user view helper
  *
  * @author Norman Heino <norman.heino@gmail.com>
  * @version $Id$
  */

class OntoWiki_Helper_CurrentUser {
	
	/**
	  * @var Holds a Zend_Auth object
	  */
	protected $auth = null;
	
	/**
	  * Gets the Zend_Auth object once an stores it for further reference
	  */
	public function __construct() {
		$this->auth = Zend_Auth::getInstance();
	}
	
	/**
	  * Returns the name of the currently logged in user or null
	  */
	public function currentUser() {
		if ($this->auth->hasIdentity()) {
			$usr = $this->auth->getIdentity();
			
			if (!isset($usr['anonymous']) || $usr['anonymous'] == 0) {
				return $usr['username'];
			}
		}
		
		return null;
	}
}

?>
