<?php

/**
  *
  *
  *
  */
class OntoWiki_Html_ResultList {
	
	protected $rows = array();
	protected $showCols;
	protected $numRows;
	protected $start;
	protected $cnt;
	
	/**
	  * Constructs an OWResultList object.
	  *
	  * @param $rows array A 2-dimensional array of rows, 
	  *        each of which is an array of column entries.
	  * @param $showCols 
	  */
	public function __construct($rows, $start, $cnt, $showCols = false) {
		$this->rows = $rows;
		$this->start = $start;
		$this->cnt = $cnt;
		$this->showCols = $showCols;
		$this->numRows = count($rows);
	}
	
	public function __destruct() {
		unset($this->rows);
		unset($this->showCols);
	}
	
	public function __toString() {
		$ret = '<table class="result" style="width:100%">' . PHP_EOL;
		
		// construct table header using array keys
		if (is_array($this->rows) && is_array($this->rows[0])) {
			$keys = array_keys($this->rows[0]);
			$ret .= '<tr><th>Nr.</th>';
			foreach ($keys as $key) {
				$ret .= '<th>' . $key . '</th>';
			}
			$ret .= '</tr>' . PHP_EOL;
		}
		
		foreach ($this->rows as $row) {
			$ret .= '  <tr>' . PHP_EOL . '    <td>' . ++$this->cnt . '.</td>';
			
			foreach ($row as $value) {
				$ret .= '    <td>';
				
				if ($value instanceof Erfurt_Rdfs_Resource) {
					// hande classes
					$ret .= '<a href="' . ontowiki::getURL($value)  . '">' . 
					$value->getQualifiedName() . '</a><br />' . $value->getType()->getQualifiedName();
				} elseif ($value instanceof Erfurt_Rdfs_Literal) {
					$ret .= $value->getLabel() . '<br />' . PHP_EOL;
				}
				$ret .= '</td>';
			}
			
			$ret .= PHP_EOL . '  </tr>' . PHP_EOL;
		}
		
		return ($ret . '</table>' . PHP_EOL);
	}
}

?>