<?php
/**
 * ContainerManager plugin main class.
 *
 * @author Maria Moritz
 * @version $Id: ContainerManager.php 2263 2008-05-12 mariamoritz $
 */
 
class ContainerManager extends OntoWiki_Plugin {
	
  	protected function _initPlugin($erfurtobject) {
  		
	    parent::_initPlugin($erfurtobject);
	    return true;	    
  	}
 
   /**
     * grabs the container action and the service controller name
     * given by the request object and
     * forwards it to the controller directory
     */
	public function grabContainer() {
		
		$frontController = Zend_Controller_Front::getInstance();
		$request = $frontController->getRequest();
		$controllerName = strtolower($request->getControllerName());
		$actionName = strtolower($request->getActionName());

		if ($controllerName == 'service' && $actionName == 'container') {
			
			// The one and only thing needed for redirecting to your own
			// controller (no setting of action or controller or sth. needed)
			$frontController->setControllerDirectory(dirname(__FILE__));			
		}
	}

    /**
     * after login a session variable is set to true
     *
     * @param string $redirectUrl
     */
	public function redirectOnLogin (&$redirectUrl) {
		/*
		$newWindow = array(
			'cssId'      => 'ContainerManager',  
			'title'      => 'Container Manager', 
			'content'    => 'hi'			
		);
		*/
		$_SESSION['bool'] = true;
    }

    /**
     * bevor the containerManager window will be displayd
     * it will be checked whether you are logged in and a model is active
     */
	public function addWindowToView(&$newWindow) {	
    # for event 'template_plugin_example_data', triggered in view (_includes/footer.php)
    	
    	if(!$_SESSION['bool'])return;
    	if(!Zend_Registry::get('config')->activeModel)return;
    	
    	$content = array(
			'cssId'      => 'ContainerManager',  
			'title'      => 'Container Manager', 
			'content'    => 'hi'			
		);
		$newWindow .= $this->_view->partial('micro/window.php', $content);
		return true;	
		
	}
	
    /**
     * adds ContainerManager.js for javascript usage
     *
     */
    public function addIncludes(&$includes){

		$includes.='<!-- ContainerManager scripts -->'. PHP_EOL;
		$includes.='<script type="text/javascript" src="'.$this->_getPluginBaseUri().'/ContainerManager.js"></script>'.PHP_EOL;
		$includes.='<!-- End of ContainerManager scripts -->'.PHP_EOL;
		return true;
	}	
}
?>