<?php

/**
  * Example Plugin Controller Class
  * 
  * Extends the OntoWiki controller action class for
  * standard functionality.
  * 
  * @author Michael Haschke
  * @version $Id$
  */
class ExamplecontrollerController extends OntoWiki_Controller_Action {

    private $_example = null;

    public function init() {
    
        // 1. call orininal parent method
        parent::init();
        
        // 2. change template folder
        // 2a. get Example plugin by Plugin Manager
        $pm = $this->erfurtApp->getPluginManager();
        $this->_example = $pm->prepare('Example');
        // 2b. use Example method to change template folder
        $this->_example->changeViewTemplate(true);
    
    }
    
    // if controller is called without an action then use exampleaction, too.
    public function indexAction() {
    
        // 1. change view script to exampleaction-view
		$vr = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
	    $vr->setScriptAction('exampleaction');
        
        // 2. use exampleaction
        return $this->exampleactionAction();
    }
    
    public function exampleactionAction()
    {
        $this->view->title = "Example Controller Test";
        // this action is doing nothing, it is just existing for example purposes
        // exampleaction-view is used automatically by Zend
    }

}

?>
