<?php

/**
 * Kartenproto, the main-class of th Plugin
 *
 * This Class manages the Plugin, by adding the controller directorys and so on.
 * @author OWMapPlugin-Team <mashup@comiles.eu>
 * @version 1.0.0
 * @package MapPlugin
 */
class MapPlugin extends OntoWiki_Plugin {

    protected function _initPlugin($erfurtobject) {
		parent::_initPlugin($erfurtobject);
        //$model=$this->MapPluginModel();
		$this->_strings = Zend_Registry::get('strings');
    }
    
    /**
     * addControllerDirectory function adds the controller directory of the plugin to the list of controller directorys
     * @return boolean
     */
    public function addControllerDirectory( ) {
        /**
         * get front controller of the zend framework, which manages everything concerning controllers
         */
        $frontController = Zend_Controller_Front::getInstance();

        /**
         * get request object which contains the userrequest with the called controller and the action
         */
        $request = $frontController->getRequest();

        /**
         * extract controller and action name from the request-URI
         */
        $controller = $request->getControllerName();
        $action     = $request->getActionName();

        /**
         * if the mapAction of the ServiceController or ResourceController is called the controller directory of the plugin will be added
         */
        if (($controller == 'service' || $controller == 'resource') && $action == 'map') {
            if ($controller == 'resource') $request->setControllerName('mappluginresource');
            $frontController->addControllerDirectory($this->_getPluginRootDir( ) . "/controller/");
        }
        return true;
    }

    /**
     * changeViewTemplate function adds the pluginspecific template directory to the scriptPath
     * @param boolean $onlyFolder
     */
    function changeViewTemplate($onlyFolder = true) {
        // for event 'default_resource_view_ZendPostDispatch', triggered automatically

        // 1. get current Renderer object
        $vr = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
        // 2. add the template folder within the plugin folder
        // using Erfurt_Plugin:_getPluginRootDir to create the absolute folder name
        $this->_view->addScriptPath($this->_getPluginRootDir().'/templates/');
        // 3. exchange the template script
        // within your template folder, the script must be in a folder called like
        // the controller (lowercase, 'resource' in our example)
        if ($onlyFolder != true) {
            $vr->setScriptAction('replace-view'); // set name (NAME.php) of template
        }
    }

    /**
     * function getPluginBaseUri() is wraped around the private _getPluginVaseUri() function
     * @param string
     */
    function getPluginBaseUri( ) {
        return $this->_getPluginBaseUri( );
    }
	
	/**
     * function getPluginRootDir() is wraped around the private _getPluginRootDir() function
     * @param string
     */
    function getPluginRootDir( ) {
        return $this->_getPluginRootDir( );
    }
}
?>
