<?php

/**
 * ServiceController of the MapPlugin
 *
 * @author OW MapPlugin-Team <mashup@comiles.eu>
 * @version 0.0.3
 * @package MapPlugin
 */
class ServiceController extends OntoWiki_Controller_Action {

    /**
     * initiates the plugin
     **/
    public function init() {
        /**
         * call the init() function of the parrent class
         */
        parent::init();

        /**
         * call the changeViewTemplate() function of the MapPlugin, to set the view template
         * you can find this function in the MapPlugin.php in the plugin root
         */
		$this->erfurtApp->getPluginManager()->prepare('MapPlugin')->changeViewTemplate(true);

    }
    /**
     * Sends Markers encoded with JSON
     * This Method can receive a request for a year by reading $_GET['year'].
     * It can also just work with a given class form the Knowledge Base.
     * @return JSON encoded list of Markers
     * @author OWMapPlugin-Team <mashup@comiles.eu>
     */
	public function mapAction() {
		$pluginRootDir = $this->erfurtApp->getPluginManager()->prepare( "MapPlugin" )->getPluginRootDir( );
		require_once( $pluginRootDir . "/classes/MarkerManager.php" );
		require_once( $pluginRootDir . "/classes/Marker.php" );
		require_once( $pluginRootDir . "/classes/Cluster.php" );
		require_once( $pluginRootDir . "/classes/Clusterer.php" );
		require_once( $pluginRootDir . "/classes/GeoCoder.php" );
		
		/**
		 * Disable layout, because we want to send pure data
		 */
		$this->_helper->layout->disableLayout();

		/**
		 * Get the active model from Zend framework
		 */
		$this->model = Zend_Registry::get('config')->activeModel;
		
		// get the filters
		if (isset($this->_request->select)) {
			$this->_filters = array_filter($this->_request->select[0]);
		} else {
			$this->_filters = array();
		}

		$markerManager = new MarkerManager( $this->model, $this->config, $this->erfurtApp );
		$markerManager->createMarkers( $this->session->activeResourceUri, $this->_filters );
//		Get the viewarea from the client and call markermanager on the given area
//		$markers = $markerManager->getMarkers(array(top,right,bottom,left) );
		$markers = $markerManager->getMarkers( explode( ",", $_GET['viewArea']), $_GET['clusterOn'], $_GET['clustGridCount'], $_GET['clustMaxMarkers'] );


		for($i = 0; $i < count($markers); $i++ ){
			if( get_class($markers[$i]) == "Cluster" ) {
				/**
				 * $content and $containingMarkers contain the same data in a different format
				 */
				$content = $markers[$i]->getContent();
				$containingMarkers = array();
				for($j = 0; $j < count($content); $j++ ) {
					$containingMarkers[] = array(
						'label' => $content[$j]->getLabel(),
						'lat' 	=> $content[$j]->getLat(),
						'long' 	=> $content[$j]->getLon(),
						'uri' 	=> $content[$j]->getUri(),
						'icon'	=> $content[$j]->getIcon()
					);
				}
				$marker_array[] = array (
					'label'		=> $markers[$i]->getLabel(),
					'lat' 		=> $markers[$i]->getLat(),
					'long'	 	=> $markers[$i]->getLon(),
					'icon'		=> $markers[$i]->getIcon(),
					'markers'	=> $containingMarkers
				);
			}
			else {
				$marker_array[] = array (
					'label' => $markers[$i]->getLabel(),
					'lat' 	=> $markers[$i]->getLat(),
					'long' 	=> $markers[$i]->getLon(),
					'uri' 	=> $markers[$i]->getUri(),
					'icon'	=> $markers[$i]->getIcon()
				);
			}
		}

		$json_array = array();
		$json_array['marker'] = &$marker_array;
		$json_array['area'] = $markerManager->getBestViewArea();
        /**
        * encode the array which contains all markers to a JSON String
        */
		$this->view->json_array = $json_array;

    }
}
?>
