<?php

/**
 * Socializr plug-in controller
 *
 * @author Thomas Kappel <tkappel@uni-leipzig.de>
 * @version $Id$
 */
class SocializrController extends OntoWiki_Controller_Action {

  /**
   * initialize Socializr
   */
	public function initializesocializrAction() {
	  $socializr            = Socializr::getInstance();
		$frontController      = Zend_Controller_Front::getInstance();
		$request              = $frontController->getRequest();
		$parameters           = $this->getParameters();
		$session              = Zend_Registry::get('session');
		$this->view->baseUri  = $socializr->getOntoWikiBaseUri();
		
		$this->view->required = /*$socializr->socializrModel() ? array() : */ array(
			'givenname'   => $socializr->_strings->soc->foaf->givenname,
			'family_name' => $socializr->_strings->soc->foaf->family_name,
		);
		
		$title = $socializr->socializrModel() ? $socializr->_strings->soc->re_initialize : $socializr->_strings->soc->initialize;
		$this->view->submitButton = $title;
		
    $received_information = $_GET["account_data"];
    if(!is_array($received_information)) $received_information = array();
		
		// Speichern nur, wenn keine Infos fehlen und überhaupt einige abgefragt wurden oder simple_confirm gesetzt ist
		if(isset($received_information['givenname']) && isset($received_information['family_name'])) {
		  $firstname = $received_information['givenname'];
      $lastname  = $received_information['family_name'];
      
      $label = (substr($firstname,-1)=="s" ? $firstname."&apos; " : $firstname."s ") . $socializr->_strings->soc->networks->network;
		  
      $my_socializr_uri = "http://localhost/ontowiki/my_socializr/";
      
      $temp_file_path = tempnam('/tmp', 'ow');
      $temp_file = fopen($temp_file_path, 'wb');
      //fwrite($temp_file, $post['paste']);
      //fclose($temp_file);
      
/*      if(!is_writable($socializr->getTempDir())) die($socializr->getTempDir()." must be writeable!");
      $temp_file_path = $socializr->getTempDir()."initial_model.rdf";
      
      if(file_exists($temp_file_path) && !is_writable($temp_file_path)) die("$temp_file_path must be writeable!");
//var_dump(__LINE__);exit;
      $temp_file = fopen($temp_file_path,"w");
      if(!$temp_file) die("$temp_file_path must be writeable!"); */
      fwrite($temp_file,'<rdf:RDF
    xml:base="'.$my_socializr_uri.'"
    xmlns:soc="http://ns.ontowiki.net/plugins/socializr/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
    xmlns:foaf="http://xmlns.com/foaf/0.1/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:owl="http://www.w3.org/2002/07/owl#"
    xmlns:rss="http://purl.org/rss/1.0/"
    xmlns:dcterms="http://purl.org/dc/terms/"
    xmlns:sioc="http://rdfs.org/sioc/ns#">

  <owl:Ontology rdf:about="http://localhost/ontowiki/my_socializr/" rdfs:label="'.$label.'">
    <rdfs:label>'.$label.'</rdfs:label>
    <owl:imports rdf:resource="http://ns.ontowiki.net/plugins/socializr/" />
  </owl:Ontology>

  <foaf:PersonalProfileDocument rdf:about="http://localhost/ontowiki/my_socializr/">
    <foaf:maker rdf:resource="me"/>
    <foaf:primaryTopic rdf:resource="me"/>
  </foaf:PersonalProfileDocument>

  <foaf:Person rdf:about="me">
    <foaf:name>'.$firstname.' '.$lastname.'</foaf:name>
    <foaf:givenname>'.$firstname.'</foaf:givenname>
    <foaf:family_name>'.$lastname.'</foaf:family_name>
  </foaf:Person>
</rdf:RDF>');
      fclose($temp_file);
      
		  $dependencies = array(
		    "http://rdfs.org/sioc/ns#"                   => "http://rdfs.org/sioc/ns#",
		    "http://xmlns.com/foaf/0.1/"                 => "http://xmlns.com/foaf/spec/index.rdf",  
		    "http://ns.ontowiki.net/plugins/socializr/"  => $socializr->getSocializrDir().'/rdf/Socializr.rdf',
		    $my_socializr_uri                            => $temp_file_path
		  );
		  // remove old models
		  /*foreach($dependencies as $url=>$source) {
        try {
          $model = $this->erfurtStore->getModel($url);
		      if($model) $this->erfurtStore->deleteModel($url);
        } catch(Exception $e) {}
		  }*/
		  
		  // an active model could not be deleted immediately, so we first choose another one 
		  $session = Zend_Registry::get('session');
      $this->config->activeModel = null;
      $session->activeModelUri = '';
		  
		  //$model = $this->erfurtStore->getModel($my_socializr_uri);
      //if($model)
      if($this->erfurtStore->getModel($my_socializr_uri)) {
        //var_dump(__LINE__);
        $this->erfurtStore->deleteModel($my_socializr_uri);
      } //else var_dump(__LINE__);
      
      // add models
      foreach($dependencies as $url=>$source) {
        $this->erfurtStore->loadModel($url,$source,false , false, false);
      }
      unlink($temp_file_path);
		  /*
      if ($model = $this->erfurtStore->getModel($my_socializr_uri)) {
        $session->activeModel = $model;
        ///$this->log->debug('Model selected: ' . $session->activeModel->modelURI);
      }
      // */

      
		  die("<script> location.href = '".$socializr->getOntoWikiBaseUri()."/model/info/?m=".urlencode($my_socializr_uri)."';</script>");
		}
		//    var_dump($accountResource->accountName);exit;
		//    $socializr->load_accounts();

		$this->view->networkName = $socializr->_strings->soc->Socializr;
		$this->view->baseUri     = $socializr->getOntoWikiBaseUri();
		$this->view->formAction  = "initialize";

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the edit-account template and assign to content
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render('socializr/edit-account.php');
		$this->view->clearVars();

		// render the window template with the content from here
    $this->view->title    = $title;
		$this->view->content  = $content;
		$this->_response->setBody('
		  <window>
        <h1 class="title">'.$title.'</h1>
        <div class="content">
          '.$content.'
        </div>
      </window>
    ');

		return;
	}
	
	/**
	 * search for unknown accounts of integrated contacts
	 */
	public function fetchunknownaccountsAction() {
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$this->view->baseUri = $socializr->getOntoWikiBaseUri();
    $session   = Zend_Registry::get('session');
    		
		$person_uri = $request->get('person_uri');
		if($person_uri) {
			$person_uri = $socializr->param2id($request->get('person_uri'));
		}
		
		$modifyNetworkStatus = $request->get('modifyAccountState');
		$launch   = $request->get('launch');
		$fetchOne = $request->get('fetchOne');

		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');

		if($modifyNetworkStatus) {
	  // (de-)aktivieren der automatischen Aktualisierung von Netzwerken
			$accountResource = $socializr->_model->resourceF($socializr->param2id($modifyNetworkStatus));
			$value = $accountResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/autoSearch");
			$value = $value->uri;

			$new_value = $value=="refresh" ? "no_refresh" : "refresh";
			$accountResource->setPropertyValue("http://ns.ontowiki.net/plugins/socializr/autoSearch", $new_value);
			$value = $accountResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/autoSearch");
			$value = $value->uri;
		}

		$person_hits = array();

		if($launch || $person_uri) {
  		$socializr->load_accounts();
  		
  		if(!$person_uri) {
        $sparqlstring = '
          PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
          SELECT * WHERE {
            ?doc foaf:primaryTopic ?me .
            ?me foaf:knows ?person .
            ?person foaf:name ?name .
  		    }';
        $results = $socializr->_model->sparqlQuery($sparqlstring);
  		} else $results = array("person_uri" => $person_uri);
      $this->view->headline    = 'Suche';
      $this->view->content     = '';

      foreach($results as $result) {
        if(!isset($result["person_uri"])) {
          $person     = $result["person"];
          $person_uri = $person->uri;
        }
        $personResource = $socializr->_model->resourceF($person_uri);
        $value = $personResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/follow");
        if($value && $value->label=="no-follow") continue;
        $name = $personResource->getPropertyValue("http://xmlns.com/foaf/0.1/name");
        if($name) $name = $name->label;

        $person_hits[] = array(
          'person'     => $name,
          'person_uri' => $person_uri,
          'encoded_uri'=> $socializr->id2param($person_uri)
        );
      }
      $this->view->person_hits = $person_hits;
      $this->view->text_addToNetwork          = $socializr->_strings->soc->fetchContacts->addToNetwork;
      $this->view->text_notSupportedByNetwork = $socializr->_strings->soc->networks->notSupportedBy;
      $this->view->text_contactInNetwork      = $socializr->_strings->soc->fetchContacts->contactInNetwork;
      $content = $this->view->render('socializr/person-search-list.php');
		} elseif($fetchOne) {
		  $person_uri = $socializr->param2id($request->get('person'));
		  $person = $socializr->_model->resourceF($person_uri);
		  
/*
		  $accountsSparqlstring = '
        PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
        SELECT * WHERE {
          <'.$request->get('person_uri').'> foaf:holdsAccount ?account .
          ?account foaf:accountName ?accountName
        }
      ';
      $accountResults = $socializr->_model->sparqlQuery($accountsSparqlstring);
      foreach($accountResults as $accountResult) {
      }
// */
      $contact=array('person_uri' => $person_uri);
      foreach($socializr->foaf_fields as $field) {
        if($value = $person->getPropertyValue("http://xmlns.com/foaf/0.1/" . $field)) $contact[$field] = $value->label;
      }
      //var_dump($contact);exit;
		  $Search = new Search();
      $hits = $Search->execute($contact);
      
      $person_hits = array(
        'person'     => $contact["name"],
        'person_uri' => $person->uri,
        'hits'       => $hits["hits"],
        'count'      => $hits["count"]
      );
      //var_dump(__LINE__);exit;
      if(!is_array($session->found_unknown_accounts)) $session->found_unknown_accounts=array();
      $session->found_unknown_accounts[$person_uri] = $hits["hits"]; // prebook for option to ignore them
      $this->view->person_hits = $person_hits;
      $this->view->text_addToNetwork          = $socializr->_strings->soc->fetchContacts->addToNetwork;
      $this->view->text_notSupportedByNetwork = $socializr->_strings->soc->networks->notSupportedBy;
      $this->view->text_contactInNetwork      = $socializr->_strings->soc->fetchContacts->contactInNetwork;
      $content = $this->view->render('socializr/person-search-result.php');
      
      $this->_helper->viewRenderer->setNoRender();
      $this->_helper->layout->disableLayout();
  
      // render the socializr view template and assign to content
      $this->view->clearVars();
  
      // render the window template with the content from here
      $this->_response->setBody($content);
  
      return;
		} else {
			//$this->view->headline    = 'Konfiguration';
			$this->view->content     = '';
		 /* foreach($socializr->getAccounts() as $account_uri=>$account) {
		  	$accountResource = $socializr->_model->resourceF($account_uri);
		  	$status = $accountResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/autoSearch");
		  	$status = $status->uri;
		  	if($modifyNetworkStatus && $account_uri == $socializr->param2id($modifyNetworkStatus)) $status = $new_value;
		  	$status_linktext = ($status == "no_refresh")
		  	? "<img src='../../plugins/Socializr/images/network_off.png' alt='switched off' />"
		  	: "<img src='../../plugins/Socializr/images/network_on.png' alt='switched on' />";
		  	$network = $account["network"];
		  	 
		  	$this->view->content  .= '<a class="replace-inline" href="'.trim($socializr->getOntoWikiBaseUri()).'/model/fetchUnknownAccounts/modifyAccountState/'.$socializr->id2param($account_uri).'">'.$status_linktext.'</a> '.$account["accountName"].'@'.$network->_Name.'<br />';
		  }
	*/
		  $this->view->content  .= '<a class="replace-inline button" href="'.trim($socializr->getOntoWikiBaseUri()).'/model/fetchUnknownAccounts/launch/true">'.$socializr->_strings->soc->assignAccounts->findAccounts.'</a>';
	
		  $content = $this->view->render('socializr/view.php');
		}


		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->fetchContacts->manageContacts;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}


	/**
	 * fetch contacts
	 */
	public function findaccountsAction() {
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$contactId = $socializr->param2id($request->get('contact_id'));
		//    $contact = $socializr->_model->listProperties($contactId);

		$sparqlstring = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> . SELECT ?property, ?value WHERE { <'.$contactId.'> ?property ?value }';
		$contact_properties     = $socializr->_model->sparqlQuery($sparqlstring);
		//    var_dump($contact_properties);exit;

		$contact = array();
		$accounts = array();
		foreach($contact_properties as $result) {
			$property = $result["property"]->uri;
			if("http://xmlns.com/foaf/0.1/" === substr($property,0,26)) $property = substr($property,26);
			else continue;
			$value    = $result["value"]->uri;
			if($property=="holdsAccount") {
				$accounts[]=$value;
			}
			if(false==$value) $value = $result["value"]->label;
			$contact[$property] = $value;
		}

		$hits = array();
		foreach($socializr->getNetworks() as $network) {
			$result = $network->findPerson($contact);
			//      if("not connected" !== $result)
			$hits[$network->_Name]=$result;
		}

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');

		$content = "";
		foreach($hits as $network=>$local_hits) {
			$this->view->headline = $network;
			$this->view->list_elements = array();
			$this->view->external_href = array();
			if(is_array($local_hits) && sizeof($local_hits)) {
				foreach($local_hits as $counter=>$hit) {
					if(in_array($socializr->getAccountUri($hit['socializr_account_uri'],$network),$accounts)) continue;
					$this->view->list_elements[$counter] = $hit["name"];
					if(isset($hit["depiction"]) && strlen($hit["depiction"]))
					$this->view->list_elements[$counter] .= ' <img src="'.$hit["depiction"].'" alt="'.$hit["name"].'" style="vertical-align: middle;width:80px" />';
					$this->view->list_elements[$counter] .= '</a> <a href="'.trim($socializr->getOntoWikiBaseUri()).'/model/add_friend_account/network/'.$network.'/account/'.$hit["socializr_account_uri"].'" class="replace-inline"><img src="../../plugins/Socializr/images/user_add.png" alt="'.$socializr->_strings->soc->networks->addAccount.'" style="vertical-align: middle" /></a>';
					$this->view->external_href[$counter] = $hit["profile_url"];
				}
				if(sizeof($this->view->list_elements)) $content .= $this->view->render('socializr/list.php');
			}
			if(!sizeof($this->view->list_elements)) {
				$this->view->content = $socializr->_strings->soc->fetchContacts->nothing_found;
				$content .= $this->view->render('socializr/view.php');
			}
		}

		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->fetchContacts->fetchNewContacts.": ".$network->_Name;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

	/**
	 * integrate contact
	 */
	public function fetchcontactAction() {
	  //prepare
    $socializr = Socializr::getInstance();
    $frontController = Zend_Controller_Front::getInstance();
    $request   = $frontController->getRequest();
    $accountId = $socializr->param2id($request->get('account'));
    $friend_not_me = false;
    
    if(!$accountId) {
      $foreignAccount = $socializr->param2id($request->get('foreign_account'));
      $foreignAccountId = $socializr->param2id($request->get('foreign_account_id'));
      if($foreignAccount && $foreignAccountId) {
        $networkName = $socializr->param2id($request->get('network'));
        eval("\$network = $networkName::getInstance();");
        //if(!$network->connect("",$foreignAccount)) return false;
        //var_dump($network);exit;

        $sparqlstring = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> . SELECT ?person WHERE { ?person foaf:holdsAccount <'.$foreignAccountId.'> }';
        $sparqlquery     = $socializr->_model->sparqlQuery($sparqlstring);
        if(sizeof($sparqlquery)!=1) return;
        $localUser       = current($sparqlquery);
        $friend_not_me = $localUser["person"];
        $friend_not_me = $friend_not_me->uri;
      }
      else 
      {
        echo('Error on line '.__LINE__);exit;
      }
    } else {
      $account   = $socializr->getAccount($accountId);
      $network   = $account["network"];
    }
    
    $accountName = $socializr->param2id($request->get('accountName'));
    if(!$accountName) return false;
    
    $contact = $network->fetchContact($accountName);
//echo('Zeile '.__LINE__.': <br />');var_dump($contact);exit;
    if(!$contact) return false;
    
    $this->view->name = $contact["name"]; 
    $this->view->about = $socializr->addPerson2Model($contact, $network, $friend_not_me);
    
    // as a service it needs no view renderer and no layout template
    $this->_helper->viewRenderer->setNoRender();
    $this->_helper->layout->disableLayout();

    // render the socializr view template and assign to content
    $this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
    $this->_response->setBody($this->view->render("socializr/fetch-contact.php"));

    return;
	}
	
	/**
	 * load list of contacts to integrate them
	 */
	public function fetchcontactsAction () {
		//prepare
	  $socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$accountId = $socializr->param2id($request->get('account'));
		$friend_not_me = false;
		if(!$accountId) {
			$foreignAccount = $socializr->param2id($request->get('foreign_account'));
			$foreignAccountId = $socializr->param2id($request->get('foreign_account_id'));
			if($foreignAccount && $foreignAccountId) {
				$networkName = $socializr->param2id($request->get('network'));
				eval("\$network = $networkName::getInstance();");

				$sparqlstring = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> . SELECT ?person WHERE { ?person foaf:holdsAccount <'.$foreignAccountId.'> }';
				$sparqlquery     = $socializr->_model->sparqlQuery($sparqlstring);
				if(sizeof($sparqlquery)!=1) return;
				$localUser       = current($sparqlquery);
				$friend_not_me = $localUser["person"];
				$friend_not_me = $friend_not_me->uri;
				$this->view->account_id = $foreignAccountId;
			}
			else 
			{
		    echo('Error on line '.__LINE__);exit;
			}
		} else {
			$account                = $socializr->getAccount($accountId);
			$network                = $account["network"];
      $networkName            = $network->_Name;
  		$this->view->account_id = $accountId;
		}
		
		$this->view->baseUri = $socializr->getOntoWikiBaseUri();

		$this->view->modelUri      = $socializr->_model->getModelURI();

		//work
		if($foreignAccount) {
			//$contacts =
			$contacts = $network->fetchContactsOfContacts($foreignAccount);
		} else {
		  //$contacts =
      $contacts =  $network->fetchContacts();
		}
		
		// we compare now the contacts saved in the model with the fetched ones
		$sparqlquery = '
		  PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
		  PREFIX soc: <http://ns.ontowiki.net/plugins/socializr/> .
		  SELECT ?accountName, ?contact_account, ?contact_name
		  WHERE {
		    ?user foaf:holdsAccount <'.$this->view->account_id.'> .
		    ?user foaf:knows ?contact .
		    ?contact foaf:name ?contact_name .
		    ?contact foaf:holdsAccount ?contact_account .
		    ?contact_account soc:networkType "'.$networkName.'" .
		    ?contact_account foaf:accountName ?accountName
	    }
		';
//var_dump($sparqlquery);exit;
		$this->view->contacts = array();
		$this->view->leaving_contacts = array(); 
		
		$results = $socializr->_model->sparqlQuery($sparqlquery);
		foreach($results as $result) {
		  $contact_accountName = $result["accountName"]->label;
		  $contact_accountURI  = $result["contact_account"]->uri;
		  if(in_array($contact_accountName, $contacts)) $this->view->contacts[]=$contact_accountURI;
		  else {
		    $contact_account = $socializr->_model->resourceF($contact_accountURI);
		    $this->view->leaving_contacts[] = $result["contact_name"]->label;
		    $contact_account->remove();
		  }
		}
		$this->view->contacts = array_diff($contacts, $this->view->contacts);
// */  $this->view->contacts = $contacts;
/*
		//var_dump($contacts);exit;
		if($contacts)	foreach($contacts as $id=>$account_name) {
			$contact =  $network->fetchContact($account_name);
			$this->view->list_elements[$id] = $contact["name"];
			$this->view->about[$id]         = $socializr->addPerson2Model($contact, $network, $friend_not_me);
		}*/
		//var_dump($this->view->list_elements);exit;
		$template = 'socializr/fetch-contacts.php';

		if($foreignAccount) unset($network);

		$this->view->headline      = ($contacts ? sizeof($contacts) : 0)." ".$socializr->_strings->soc->fetchContacts->foundContacts;

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render($template);
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->fetchContacts->fetchNewContacts.": ".$network->_Name;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

	/**
	 * fetch personal information of an account
	 */
  public function fetchunknownpersondetailsAction () {
    //prepare
    $socializr = Socializr::getInstance();
    $frontController = Zend_Controller_Front::getInstance();
    $request   = $frontController->getRequest();
    $accountName = $socializr->param2id($request->get('account'));
    $networkName = $socializr->param2id($request->get('network'));
    
    $contact_data = array(); // there may be several accounts with different fetchable information => merge them
    // find own account(s) of this network
    foreach($socializr->getAccounts() as $account) {
      $network = $account["network"];
      if($network->_Name != $networkName) continue;
      
      $contact_data = array_merge($contact_data, $network->fetchContact($accountName));
    }
    $this->view->rows = array();
    foreach($contact_data as $field=>$value) {
      if(!strlen($value) || !in_array($field,$socializr->foaf_fields)) continue;
      $human_readable_field_name = $socializr->_strings->soc->foaf->$field;
      if(!$human_readable_field_name) $human_readable_field_name = $field;
      
      if(substr($value,0,7) == "http://") $value='<a href="'.$value.'" target="tab"><img src="'.$socializr->getOntoWikiBaseUri().'/plugins/Socializr/images/magnifier.png" alt="'.$value.'" /></a>';
      $this->view->rows[$human_readable_field_name] = $value;
    }
    $this->view->id      = $networkName."_".$accountName;
    $this->view->baseUri = $socializr->getOntoWikiBaseUri();
    
    // as a service it needs no view renderer and no layout template
    $this->_helper->viewRenderer->setNoRender();
    $this->_helper->layout->disableLayout();
    
    // render the socializr view template and assign to content
    $this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
    $this->_response->setBody($this->view->render("socializr/table.php"));
    
    return;
  }
	
	/**
	 * delete an account of the user
	 */
	public function clearaccountAction() {
		//var_dump(__LINE__);exit;
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$parameters = $this->getParameters();

		if(isset($parameters['account'])) $accountId = $socializr->param2id($parameters['account']);
		else $accountId = $socializr->param2id(urldecode($request->get("account")));
		if(!$accountId) return false;

		$sparqlstring = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> . SELECT ?me WHERE { ?doc foaf:primaryTopic ?me }';
		$sparqlquery = $socializr->_model->sparqlQuery($sparqlstring);
		if(sizeof($sparqlquery)!=1) return;
		$localUser = current($sparqlquery);
		$me        = $localUser["me"];
	
		$socializr->_model->remove(
  		$me,
  		new Resource("http://xmlns.com/foaf/0.1/holdsAccount"),
  		$socializr->_model->resourceF($accountId)
		);

		$this->view->headline      = $socializr->_strings->soc->networks->account_cleared;
		$this->view->content       = '<script type="text/javascript">document.location.href="'.trim($socializr->getOntoWikiBaseUri()).'/model/info/?m='.$socializr->_model->getModelURI().'";</script>';
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render("socializr/view.php");

		$this->view->clearVars();

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		$this->view->title      = "&nbsp;";
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));
		//var_dump($this->_response);exit;

		return;
	}

	/**
	 * edit an account of the user
	 */
	public function editaccountAction() {
		//prepare
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$parameters = $this->getParameters();
		if(isset($parameters['account'])) $accountId = $socializr->param2id($parameters['account']);
		else $accountId = $request->get("account");
		//	  	var_dump(__LINE__);exit;
		if(!$accountId) return false;
		$this->addAccountAction($accountId);
	}

	/**
	 * return: array of parameters given in the url 
	 */
	protected function getParameters() {
		$socializr       = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request         = $frontController->getRequest();
		if(isset($_GET["parameters"])) {
			$parameters=$_GET["parameters"];
			$separator_pos = strpos($parameters,"/");
			if($separator_pos) return array(substr($parameters,0,$separator_pos) => substr($parameters, $separator_pos+1));
		}
		return array();
	}

	/**
	 * add an account
	 */
	public function addaccountAction ($accountId = false) {
		$socializr       = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request         = $frontController->getRequest();
		$parameters      = $this->getParameters();
		//var_dump(__LINE__);exit;
		if(isset($parameters['account']))  $accountId = $socializr->param2id($parameters['account']);
		if(!isset($parameters['network'])) $network   = $request->get('network');
		else $network=$parameters['network'];
		if(!$accountId) {
			//	  	var_dump(__LINE__);
			$availableNetworks = $socializr->getNetworks();
			if(!isset($availableNetworks[ucfirst(strtolower($network))])) return false;
			$network = new $network;
			//var_dump($network);exit;
			$account = array(
      	"accountName" => false,
      	"networkType" => $network->_Name,
      	"network"     => $network
			);
			$this->view->formAction   = 'addAccount';
			$this->view->parameters   = 'network/'.$network->_Name;
			$this->view->submitButton = $socializr->_strings->soc->networks->addAccount;
			$this->view->clearButton  = false;
		} else {
			//var_dump(__LINE__);exit;
			$this->view->formAction   = 'editAccount';
			$this->view->parameters   = 'account/'.$socializr->param2id($accountId);
			$this->view->submitButton = $socializr->_strings->soc->networks->editAccount;
			$this->view->clearButton  = $socializr->_strings->soc->networks->clearAccount;
			$this->view->accountUri   = $socializr->param2id($accountId);
			$account   = $socializr->getAccount($this->view->accountUri);
			$network   = $account["network"];
			//			var_dump($accountId);
			//var_dump($account);
		}

		$this->view->baseUri = $socializr->getOntoWikiBaseUri();
		$session   = Zend_Registry::get('session');
		$information = $network->getAccountingRequirements();
		$required_information = $information["mandatory"];
		$optional_information = $information["optional"];
		$all_information      = array_merge ($required_information, $optional_information);
		$received_information = $_GET["account_data"];
		$missing_information  = array();
		if(!is_array($received_information)) $received_information = array();
		foreach($required_information as $required_item) {
			if(!isset($received_information[$required_item]) || !strlen($received_information[$required_item]))
			$missing_information[]=$required_item;
		}
		if(!$required_information && $accountId) $this->view->submitButton = false; // no information needed for this network, so editing is disabled
		else {
			$this->view->required  = array();
			$this->view->value     = array();
			$this->view->duty      = array();
			$this->view->highlight = array();
			foreach($all_information as $req) {
				$expected_key = $req;
				if(!isset($session->$expected_key) && !$_POST[$expected_key]) {
					$this->view->required[$expected_key]   = $socializr->_strings->soc->networks->required_fields->$expected_key;
					$this->view->value[$expected_key]      = isset($received_information[$expected_key]) ? $received_information[$expected_key] : $account[($expected_key=="user" ? "accountName" : $expected_key)];
					$this->view->duty[$expected_key]       = in_array($req, $required_information);
					$this->view->highlight[$expected_key]  = ($this->view->duty[$expected_key] && isset($_GET['simple_confirm']) && 1==$_GET['simple_confirm'] && (!isset($received_information[$expected_key]) || !strlen($received_information[$expected_key])));
				} else $this->view->value[$expected_key] = $received_information[$expected_key]? $received_information[$expected_key] : $session->$expected_key;
			}
		}

		//    var_dump(sizeof($required_information));
		// Speichern nur, wenn keine Infos fehlen und überhaupt einige abgefragt wurden oder simple_confirm gesetzt ist
		if((sizeof($required_information) || (isset($_GET['simple_confirm']) && 1==$_GET['simple_confirm'])) && !sizeof($missing_information)) { // all mandatory fields were filled out
			if($accountId) {
				$account_uri = $socializr->getAccountUri($accountId, $account["networkType"]);
			} else {
				if(isset($received_information["user"])) $accountId = strip_tags($socializr->id2param($received_information["user"]));
				else                      $accountId = mktime();
				//			echo $account["networkType"];exit;
				$account_uri = $socializr->getAccountUri($accountId, $account["networkType"]);
//var_dump($account_uri);exit;
				$n3_prefixes = '
					@prefix foaf: <http://xmlns.com/foaf/0.1/> .
					@prefix rdfs: <http://rdfs.org/sioc/ns#> .
					@prefix soc: <http://ns.ontowiki.net/plugins/socializr/> .';
				$n3_statement = '
					<'.$account_uri.'> a foaf:OnlineAccount;
					  rdfs:label "'.$network->_Name.$this->_strings->soc->fetchContacts->NetworkAccountOf.' '.$socializr->me["name"].' - '.$accountId.'";
					  foaf:accountServiceHomepage <'.$network->getServiceHomepage().'> .
				';
				$n3 = $n3_prefixes.$n3_statement;

				// comment this out to pass the n3 using a temporary file
				$use_file = false;

				if($use_file) {
					$n3_filename = $socializr->getTempDir();
					//			echo __LINE__;exit;
					if(file_exists($n3_filename) && !is_writable($n3_filename)) {
						die("Could not write existing temporary file $n3_filename");
					}
					$temp=fopen($n3_filename,"w");
					if(!$temp) die("Could not write temporary file $n3_filename");
					fputs($temp,$n3);
					fclose($temp);
				}

				$newModel = new MemModel();
				$newModel->loadFromString($use_file ? $n3_filename : $n3, 'n3');
				$socializr->_model->addModel($newModel);
				 
				$sparqlstring = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> . SELECT ?me, ?name WHERE { ?doc foaf:primaryTopic ?me . ?me foaf:name ?name }';
				$sparqlquery = $socializr->_model->sparqlQuery($sparqlstring);
				if(sizeof($sparqlquery)!=1) return;
				$localUser = current($sparqlquery);
				$me        = $localUser["me"];
				//				var_dump($me);exit;
				$socializr->_model->add(
				  new Statement(
				    $socializr->_model->resourceF($me),
				    new Resource("http://xmlns.com/foaf/0.1/holdsAccount"),
				    $socializr->_model->resourceF($account_uri)
				  )
				);
			}

			//    var_dump(__LINE__); // exit;
			$accountResource = $socializr->_model->resourceF($account_uri);
//var_dump($accountResource);
//var_dump($account["networkType"]);
			//var_dump($received_information);
			$accountResource->setPropertyValue("http://ns.ontowiki.net/plugins/socializr/networkType", strip_tags($account["networkType"]));//$network->getServiceHomepage());
			//			$accountResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/networkType")->setLabel(strip_tags($account["networkType"]));
			if($received_information['user']) {
				//        print "<br />before saving User: ".$accountResource->getPropertyValue("http://xmlns.com/foaf/0.1/accountName")."<br />";
				$accountResource->setPropertyValue("http://xmlns.com/foaf/0.1/accountName", strip_tags($received_information['user']));
				//print "<br />User saved: ".$accountResource->getPropertyValue("http://xmlns.com/foaf/0.1/accountName")."<br />";
			}

			foreach($received_information as $key=>$information) {
				if($key!="user" && $key!="simple_confirm") {
					if($key=="pass") $key="password";
					          //print "<br />Speichere $key: ".strip_tags($information);
					$accountResource->setPropertyValue("http://ns.ontowiki.net/plugins/socializr/".strip_tags($key), strip_tags($information));
				}
			}
//exit;

			//      $socializr->load_accounts();
			//var_dump($socializr->param2id($accountId));
			//$account   = $socializr->getAccount($socializr->param2id($accountId));
			//var_dump($account);
			$this->view->pre_message = $socializr->_strings->soc->networks->savedAccount.'
			  <script type="text/javascript">document.location.href="'.trim($socializr->getOntoWikiBaseUri()).'/model/info/?m='.$socializr->_model->getModelURI().'";</script>';
		}
		//    var_dump($accountResource->accountName);exit;
		//    $socializr->load_accounts();

		$this->view->networkName = $account["networkType"];
		$this->view->baseUri = $socializr->getOntoWikiBaseUri();

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the edit-account template and assign to content
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render('socializr/edit-account.php');
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $network->_Name;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

	/**
	 * display a message
	 */
	public function messageAction() {
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();

		$networkName = ucfirst($socializr->param2id($request->get('network')));
		$messageType = $request->get('type');
		$message     = $request->get('message');
		$networks    = $socializr->getNetworks();
		$network = $networks[$networkName];
		 
		switch($messageType) {
			case 'login':
				//if(method_exists($network,"do_get_session")) $network->do_get_session($_GET["auth_token"]);
				//	    	else {
				print "Login war nicht erfolgreich - so ein Mist. Hier fehlt noch die Fehlerbehandlung.";
				exit;
				//	    	}
				if($message=="success") {
					$body = $socializr->_strings->soc->network->connected;
				} else {
					$body = $socializr->_strings->soc->networks->unsupported;
				}
				//var_dump(__LINE__);exit;
				//        $network->do_get_session($_GET["auth_token"]);
				$body.= '<script type="text/javascript"">if(parent!=self) parent.location.href="'.$socializr->getOntoWikiBaseUri().'/model/info/?m='.$socializr->_model->getModelURI().'";</script>';
				break;
				}
				$this->view->headline = $networkName;
				$this->view->content  = $body;
				 
				// as a service it needs no view renderer and no layout template
				$this->_helper->viewRenderer->setNoRender();
				$this->_helper->layout->disableLayout();

				// render the socializr view template and assign to content
				$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
				$content = $this->view->render('socializr/view.php');
				$this->view->clearVars();

				// render the window template with the content from here
				$this->view->title      = $network->_Name;
				$this->view->content    = $content;
				$this->_response->setBody($this->view->render('micro/window.php'));

				return;
		}

  /**
   * disconnect from a network
   */
	public function disconnectAction () {
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$accountId = $socializr->param2id($request->get('account'));
		//    var_dump($accountId);
		//    if(!$accountId) return false; // not needed for all networks
		if($accountId) {
			$account   = $socializr->getAccount($accountId);
	  	$network   = $account["network"];
		} else {
			print "Error";
			exit;
		}
		$this->view->baseUri = $socializr->getOntoWikiBaseUri();

		// work
		if(method_exists($network,"disconnect")) $network->disconnect();

		//    $content = $this->view->render('socializr/'.$result["template"].'.php');

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->networks->disconnect.": ".$network->_Name;
		$this->view->content    = "";
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

	/**
	 * connect to a network
	 */
	public function connectAction () {
		//prepare
		$log = Zend_Registry::get('owLog');
		$log->debug('Action started: connectAction');
		//var_dump(__LINE__);exit;
		$socializr = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request   = $frontController->getRequest();
		$accountId = $socializr->param2id($request->get('account'));
		//    var_dump($accountId);
		//		if(!$accountId) return false; // not needed for all networks
		if(strlen($request->get('account')) && $accountId) {
			$account     = $socializr->getAccount($accountId);
			$network     = $account["network"];
			$networkName = $network->_Name;
		} else {
      $networkName = ucfirst($socializr->param2id($request->get('network')));
	    $networks    = $socializr->getNetworks();
	    $network     = $networks[$networkName];
		}
		$this->view->baseUri = $socializr->getOntoWikiBaseUri();

		$this->view->headline      = $network->_Name;
		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');

		//work
		$result = $network->connect(false, $account["accountName"],$request->get('password'));
		/*
		 * returns array(
		 *       "code"        => $code,
		 *       "message"     => $message,
		 *       "template"    => $template,
		 *       "action"      => $action,
		 *       "reload"      => $reload,
		 *       "user"        => $user
		 * );
		 */
		//var_dump(__LINE__);var_dump($result);  exit;
		$this->view->name = $network->_Name;
		switch($result["template"]) {
			case "iframe":
				//var_dump(__LINE__);var_dump($result["action"]);
				$this->view->url = $result["action"];
				break;
			case "message":
				$result["template"] = "view";
				//var_dump(__LINE__);var_dump($result["action"]);exit;
				$this->view->headline = $network->_Name;
				$this->view->content  = $result["message"];
				if($result["reload"]) $this->view->content .= '
      <script type="text/javascript"">
        <!--
          var target = "'.$socializr->getOntoWikiBaseUri().'/model/info/?m='.$socializr->_model->getModelURI().'";
          if(parent!=self)
            parent.location.href = target;
          else location.href = target;
        -->
      </script>';
				break;
			case "enter_password":
			  $this->view->message     = $socializr->_strings->soc->networks->enter_pass->$result["message"];
			  $this->view->account     = $request->get('account');
			  $this->view->networkName = $networkName;
			  break;
		}
		$content = $this->view->render('socializr/'.$result["template"].'.php');

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		$about_network = call_user_func("about" .$network->_Name);
    $human_readable_network_name = $about_network["name"];
      
		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->networks->connect.": ".$human_readable_network_name;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

	/**
	 * set some foreign accounts to be ignored while searching unknown accounts of contacts 
	 */
	public function ignoreaccountAction() {
    // prepare
    $socializr       = Socializr::getInstance();
    $frontController = Zend_Controller_Front::getInstance();
    $request         = $frontController->getRequest();
    $person_uri      = Socializr::param2id($request->get('person'));
    //$account_name    = $request->get('accountName');
    $network_name    = $request->get('network');
    $session   = Zend_Registry::get('session');

    
    // get all found accounts for this person in the specified network
    $accounts = $session->found_unknown_accounts[$person_uri][$network_name];
//if(!is_array($accounts)) {var_dump(__LINE__);var_dump($accounts);exit;}
    foreach($accounts as $account) {
      $account_name = $account['accountName'];
          
  	  $account_uri = $socializr->getAccountUri($account_name, $network_name);
  	  // check if account is already known
      $sparql_account = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
        ASK WHERE {?account foaf:OnlineAccount <'.$account_uri.'>}';
      if(!$socializr->_model->sparqlQuery($sparql_account)) { // account does not exist
        $n3 = '
          @prefix foaf: <http://xmlns.com/foaf/0.1/> .
          @prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> .
          @prefix soc: <http://ns.ontowiki.net/plugins/socializr/> .
          <'.$account_uri.'> a foaf:OnlineAccount;
            soc:networkType "'.$network_name.'";
            foaf:accountName "'.$account_name.'". 
        ';
        $newModel = new MemModel();
        $newModel->loadFromString($n3, 'n3');
        $socializr->_model->addModel($newModel);
      }
      $socializr->_model->add(
        new Statement(
          $socializr->_model->resourceF($person_uri),
          new Resource("http://ns.ontowiki.net/plugins/socializr/holdsAccountNot"),
          $socializr->_model->resourceF($account_uri)
        )
      );      
    }
      
    // as a service it needs no view renderer and no layout template
    $this->_helper->viewRenderer->setNoRender();
    $this->_helper->layout->disableLayout();

    $this->_response->setBody('<img src="../../plugins/Socializr/images/cancel.png" alt="X" />');
    //var_dump($this->_response);exit;

    return;
	}
	
	/**
	 * handle some input
	 */
	public function socializrupdateAction() {
		//prepare
		$log = Zend_Registry::get('owLog');
		$log->debug('Action started: connectAction');
//var_dump(__LINE__);exit;
		$socializr  = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request    = $frontController->getRequest();
		$nextAction = $_GET['nextAction'];
//var_dump($nextAction);exit;
	  switch($nextAction) {
	  	case "addAccount" : $this->addaccountAction();          break;
	  	case "editAccount": $this->editaccountAction();         break;
	  	case "initialize" : $this->initializesocializrAction(); break;
	  	case "connect"    : $this->connectAction();             break; 
	  }
	}

	/**
	 * show the form for assigning and managing contacts
	 */
	public function assignaccountsAction() {
		//var_dump(__LINE__);exit;
		$socializr       = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request         = $frontController->getRequest();
		$mode            = $request->get('mode');

		$switch_state  = $request->get('switch_account_state');
    if($switch_state) {
      // (de-)aktivieren der automatischen Suche nach weiteren Konten
      $personResource = $socializr->_model->resourceF($socializr->param2id($switch_state));
      $value = $personResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/follow");
      $value = $value->label;

      $new_value = $value=="no_follow" ? "follow" : "no_follow";
      $personResource->setPropertyValue("http://ns.ontowiki.net/plugins/socializr/follow", new Literal($new_value));
      $value = $personResource->getPropertyValue("http://ns.ontowiki.net/plugins/socializr/follow");
      $value = $value->label;
    }

		
		$this->view->double_window = false;
		if(!$mode || ($mode!="merge" && $mode!="knows")) $mode = "merge";
		else $this->view->double_window = false;

		$this->view->mode        = $mode;
		$this->view->baseUri     = $socializr->getOntoWikiBaseUri();
		$this->view->leftBoxUri  = "listaccounts/side/left/mode/$mode";
		$this->view->rightBoxUri = "listaccounts/side/right/mode/$mode";
		$this->view->modelUri    = $socializr->_model->getModelURI();

		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render('socializr/assign-accounts.php');
		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->fetchContacts->manageContacts;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

 /**
   * merge contacts and set them in a relation to each other
   */
	public function assignaccountAction() {
		// prepare
		$socializr       = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request         = $frontController->getRequest();
		$new_person      = Socializr::param2id($request->get('new_person'));
		$moved_person    = Socializr::param2id($request->get('moved_person'));
		$method          = $request->get('method');
		if($socializr->relations[$method]["transitive"]) {
      // for instance set owl:sameAs
      $socializr->assignPersons($moved_person, $new_person, $socializr->relations[$method]["uri"]);
		} else {
			$socializr->_model->add(
			$socializr->_model->resourceF($new_person),
			new Resource($socializr->relations[$method]["uri"]),
			$socializr->_model->resourceF($moved_person)
			);
			break;
		}

		// render
		$this->view->headline = "";
		$this->view->content .= "done.";

		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');
		$content = $this->view->render('socializr/view.php');
		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = "";
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}

 /**
   * List available accounts and contacts
   *
   * @return void
   */
	public function listaccountsAction() {
		//var_dump(__LINE__);exit;
		$socializr       = Socializr::getInstance();
		$frontController = Zend_Controller_Front::getInstance();
		$request         = $frontController->getRequest();
		$person2move     = $request->get('moved_person');
		$this->view->side= $request->get('side');
		$search          = $request->get('search');
		$template        = "";
		$full_names      = array();

		if($search=="undefined" || $search==$socializr->_strings->soc->assignAccounts->filter) $search = false;

		// collect open accessible networks
		$fetchable_networks = array();
		foreach($socializr->availableNetworks as $network) {
			$network = new $network;
			$information = $network->getAccountingRequirements();
			$required_information = $information["mandatory"];
			if($network->supports('find_friends_of_friends')) $fetchable_networks[]=$network->_Name;
		}

		if(!$person2move) { // show form
			$this->view->persons = array();
			$merged_persons = array();
			$sparql_persons = '
			PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
			PREFIX soc: <http://ns.ontowiki.net/plugins/socializr/> .
      SELECT * WHERE {
      ?person foaf:name ?name 
      
      . OPTIONAL { ?person foaf:nick ?nick } 
      . OPTIONAL { ?person owl:sameAs ?otherPerson } 
      . OPTIONAL { ?person soc:follow ?follow }
      }
      ORDER BY ?name';
			$persons = $socializr->_model->sparqlQuery($sparql_persons);
			$relevant_persons = array();
			
			$count = 0;

			foreach($persons as $person) {
				$personObject = $person["person"];
				$personUri    = $personObject->uri;
				if($personUri == $socializr->_model->getModelURI().'me') continue; // ignore own accounts
				$name = $person["name"];
				$name = $name->label;
				if(isset($person["nick"])) {
					$nick = $person["nick"];
					$nick = $nick->label;
				} else $nick = "";
				
        if(isset($person["follow"])) {
          $follow = $person["follow"];
          $follow = $follow->label;
        } else $follow = "follow";
				$relevant_persons[$personUri] = ($search && (substr_count(strtolower($name),strtolower($search)) || substr_count(strtolower($nick),strtolower($search))));

				$accountsOfPerson = array();
				$sparql_account = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/> .
        PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> . 
        PREFIX soc: <http://ns.ontowiki.net/plugins/socializr/> .
        SELECT * WHERE {
          <'.$personUri.'> foaf:holdsAccount ?account
          . ?account foaf:accountName ?accountName
          . ?account rdfs:label ?accountLabel
          . ?account soc:networkType ?networkType
			  }
        ORDER BY ?accountName';
				$accounts = $socializr->_model->sparqlQuery($sparql_account);
				foreach($accounts as $persons_account) {
					$accountLabel = $persons_account["accountLabel"];
					$accountLabel = $accountLabel->label;
					$accountName  = $persons_account["accountName"];
					$accountName  = $accountName->label;
					if($search && !$relevant_persons[$personUri] && substr_count(strtolower($accountLabel),strtolower($search))) $relevant_persons[$personUri]=true;
					$account = $persons_account["account"];
					$account = $account->uri;
					$networkType = $persons_account["networkType"];
					$networkType = $networkType->label;
					$accountsOfPerson[$account] = array(
          'account_label' => $accountLabel,
          'account_name'  => $accountName,
          'fetchable'     => (in_array($networkType, $fetchable_networks) ? 1 : 0),
         // 'account_follow'=> $follow,
					'networkType'   => $networkType
					);
				}
				if(isset($person["otherPerson"])) {
					$otherPerson = $person["otherPerson"];
					$otherPerson = $otherPerson->uri;
					
					if(isset($otherPerson)) {
					  if($relevant_persons[$otherPerson]) $relevant_persons[$personUri]=true;
					  if($relevant_persons[$personUri]) $relevant_persons[$otherPerson]=true;
  					// Does it look like a real name? So let's overwrite it!
  					if(!isset($full_names[$otherPerson]) or preg_match('%^([A-Z]\w*\.? )*[A-Z]\w+$%', $name)) $full_names[$otherPerson] = $name;
  					
						if(isset($merged_persons[$personUri])) {
							$merged_persons[$otherPerson] = array_merge($accountsOfPerson, $merged_persons[$personUri]);
							$merged_persons[$personUri] = array();
						} else {
							$merged_persons[$otherPerson] = $accountsOfPerson;
						}
					} else {
            // Does it look like a real name? So let's overwrite it!
					  if(!isset($full_names[$personUri]) or preg_match('%^([A-Z]\w*\.? )*[A-Z]\w+$%', $name)) $full_names[$personUri] = $name;
					  					  
					  if(isset($merged_persons[$personUri]))
					    $merged_persons[$personUri] = array_merge($accountsOfPerson, $merged_persons[$personUri]);
					  else
					    $merged_persons[$personUri] = $accountsOfPerson;
					  $count++;
					}
				} else {
          $full_names[$personUri] = $name;
				  $merged_persons[$personUri] = $accountsOfPerson;
				  $count++;
				}
				$person_name[$personUri] = $name;
				$person_follow[$personUri] = $follow;
			}

			/*
       * initialize pager
       */
      $limit  = intval($request->get('limit'));
      if(!$limit || $limit<1 || $limit>50) $limit = $socializr->_config->pager->limit;
			
			$offset = intval($request->get('offset'));
			if($offset>$count || $offset<0) $offset=0;

			$this->view->count  = $count;
			$this->view->limit  = $limit;
			$this->view->offset = $offset;
			
      $ret = array();
      if($count > $limit) {
        $firstHtml = '&laquo;&nbsp;'.$socializr->_strings->soc->pager->first;
        $prevHtml  = '&lsaquo;&nbsp;'.$socializr->_strings->soc->pager->previous;
        $nextHtml  = $socializr->_strings->soc->pager->next .'&nbsp;&rsaquo;';
        $lastHtml  = $socializr->_strings->soc->pager->last .'&nbsp;&raquo;';
    
    
        if ($count > $limit) {
          if ($offset > 0) {
            $ret[] = '<a class="pager first-page" side="' . $this->view->side . '">' . $firstHtml . '</a>';
            $ret[] = '<a class="pager previous-page" side="' . $this->view->side . '">' . $prevHtml . '</a>';
          } else {
            $ret[] = '<a class="disabled">' . $firstHtml . '</a>';
            $ret[] = '<a class="disabled">' . $prevHtml . '</a>';
          }
        }
    
        for ($i = max($offset / $limit - 3, 0); $i < min($offset / $limit + 4, $count / $limit); $i++) {
          if ($offset == $i * $limit) {
            $ret[] = '<a class="pager page selected" side="' . $this->view->side . '" id="page-' . ($i + 1) . '">' . ($i + 1) . '</a> ';
          } else {
            $ret[] = '<a class="pager page" side="' . $this->view->side . '" id="page-' . ($i + 1) . '">' . ($i + 1) . '</a>';
          }
        }
    
        if ($offset + $limit < $count) {
          $ret[] = '<a class="pager next-page" side="' . $this->view->side . '">' . $nextHtml . '</a>';
          $ret[] = '<a class="pager last-page" side="' . $this->view->side . '">' . $lastHtml . '</a>';
        } else {
          $ret[] = '<a class="disabled">' . $nextHtml . '</a>';
          $ret[] = '<a class="disabled">' . $lastHtml . '</a>';
        }
      }
			
      $counter_visible = -$offset;
				//var_dump($full_names);exit;
			foreach($merged_persons as $personUri=>$merged_person) {
				if(($search && !$relevant_persons[$personUri]) || !sizeof($merged_persons[$personUri])) continue;
				$counter_visible++;
				if($counter_visible<1)      continue;
				if($counter_visible>$limit) break; 
				$this->view->persons[] = array(
          'name'     => $full_names[$personUri],
          'accounts' => $merged_persons[$personUri],
          'uri'      => $personUri,
          'follow'   => $person_follow[$personUri]
				);
			}
			$this->view->pagerLinks = $ret;
			$template = "account-search-box";
		} else { // there is an account to be assigned to another contact
			$template = "view";
		}

		$this->view->baseUri = $socializr->getOntoWikiBaseUri();

		$this->view->addScriptPath(REAL_BASE . 'plugins/Socializr/templates/');

		$content = $this->view->render('socializr/'.$template.'.php');

		// as a service it needs no view renderer and no layout template
		$this->_helper->viewRenderer->setNoRender();
		$this->_helper->layout->disableLayout();

		// render the socializr view template and assign to content
		$this->view->clearVars();

		// render the window template with the content from here
		$this->view->title      = $socializr->_strings->soc->assignAccounts->assignAccounts;
		$this->view->content    = $content;
		$this->_response->setBody($this->view->render('micro/window.php'));

		return;
	}
}

?>
