<?php

define('OW_CONFIG', 'http://localhost/OntoWiki/Config/');


/**
 * Cofundos plugin main class.
 *
 * @author fan_zhang@informatik.uni-leipzig.de
 */
class SoftWikiIntegrator extends OntoWiki_Plugin {


	private $_config = null;
	private $_session = null;
	private $_model = null;
	private $_erfurt = null;
	private $_store = null;
	private $_strings = false;
	private $_ac = null;
	private $dologin = null;
	private $isIntegrated = null;
	

	protected function _initPlugin($erfurtobject) {

		parent::_initPlugin($erfurtobject);

		$pluginConfig = new Zend_Config_Ini(dirname(__FILE__).'/config.ini', 'session');
		if (!isset($_SESSION['swint_user'])) $_SESSION['swint_user'] = $pluginConfig->get('swint_user');
		
		if (!isset($_SESSION['swint_password'])) $_SESSION['swint_password'] = $pluginConfig->get('swint_password');
		if (!isset($_SESSION['swint_projectid'])) $_SESSION['swint_projectid'] = $pluginConfig->get('swint_projectid');
		if (!isset($_SESSION['swint_title'])) $_SESSION['swint_title'] = $pluginConfig->get('swint_title');
		if (!isset($_SESSION['swint_prefix']))  $_SESSION['swint_prefix'] = $pluginConfig->get('swint_prefix');
		if (!isset($_SESSION['swint_modelbaseuri'])) $_SESSION['swint_modelbaseuri'] = $pluginConfig->get('swint_modelbaseuri');
		return true;

	}


	/**
	 *
	 * @return unknown_type
	 */
	public function logon(){

		$this->_config  = Zend_Registry::get('config');
		$this->_session = Zend_Registry::get('session');
		$this->_erfurt  = Zend_Registry::get('erfurt');
		$this->_store   = Zend_Registry::get('erfurt')->getStore();
		$this->_strings = Zend_Registry::get('strings');
		$this->_ac      = Zend_Registry::get('ac');

		
		$auth = Zend_Auth::getInstance();
		$identity = $auth->getIdentity();
		
		if($_SESSION['swint_user']===''||$_SESSION['swint_user']==='Anonymous'){
			if($identity['username']!=='Anonymous'){
				$auth->clearIdentity();
			}
			$this->isIntegrated=false;
			$this->dologin = false;
		}

		else{
			//if cf-user === sw-user
			if (!$_SESSION['swint_prefix']=="") $prefix=$_SESSION['swint_prefix']."_";
			if($identity['username'] === $prefix.$_SESSION['swint_user']){
				if(isset($_SESSION['swint_old_projectid'])){
					//user CHANGE the project site
					//do LOGIN
					if($_SESSION['swint_projectid']!==$_SESSION['swint_old_projectid']){
						$auth->clearIdentity();
						$this->dologin = true;
						$_SESSION['swint_old_projectid']=$_SESSION['swint_projectid'];
					}
					//user NOT CHANGE the cd project site
					//NOT DO LOGIN
					else{ 
						$this->isIntegrated=true;
						$this->dologin = false;
					}
				}
				//NEW user in the sw site during this session
				//DO LOGIN
				else {
					$this->dologin = true;
					$_SESSION['swint_old_projectid']=$_SESSION['swint_projectid'];
				}
			}
			else{
				$_SESSION['swint_old_projectid']=$_SESSION['swint_projectid'];
				if($identity['username'] === 'Anonymous'){
					$this->dologin = true;
				}
				else{
					$auth->clearIdentity();
					$this->dologin = true;
				}
			}
		}


		/*
		 * login process
		 *
		 * ---------- action chain -----------
		 * 1	user?
		 * 1.1	admin right!!!
		 * 1.2  as user login
		 * 2	usergroup?
		 * 3	membership?
		 * 4	model?
		 * 5	req?
		 * 1.3	delete admin right!!!
		 * 6    login 
		 * -----------------------------------
		 */
		
		if($this->dologin){
			$store = Zend_Registry::get('erfurt')->getStore();
			$projuri=$_SESSION['swint_modelbaseuri'].$_SESSION['swint_projectid'].'/';

			// --- check the existence of user
			$isUserFound=false;
			$sparql = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/>
				PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>				
				SELECT ?nick           
           		WHERE { ?s rdf:type foaf:Agent .  ?s foaf:nick ?nick }';

			$nicklist=$store->executeSparql($store->getModel(OW_CONFIG), $sparql, null, 'xml');
			if(strpos($nicklist, '<binding name="nick"><literal>'.$_SESSION['swint_user'].'</literal>')>0)
			$isUserFound=true;

			if(!$isUserFound){
				$str='<?xml version="1.0" encoding="UTF-8" ?>
						<!DOCTYPE rdf:RDF [
    					<!ENTITY SysOnt "http://ns.ontowiki.net/SysOnt/">
    					<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    					<!ENTITY foaf "http://xmlns.com/foaf/0.1/">
    					<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    					<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
					]>
					<rdf:RDF xml:base="'.OW_CONFIG.'"
  					xmlns:SysOnt="&SysOnt;"
  					xmlns:rdf="&rdf;"
  					xmlns:foaf="&foaf;"
  					xmlns:rdfs="&rdfs;">
 					'.
				//------------------option???---------------------
				/*
				 '<foaf:Group rdf:about="DefaultUserGroup"
				 rdfs:label="DefaultUserGroup">
				 <foaf:member rdf:resource="'.$_SESSION['swint_user'].'" />
				 </foaf:Group>'.
				 */
					'<foaf:Agent rdf:about="'.$_SESSION['swint_user'].'"
      				foaf:nick="'.$_SESSION['swint_user'].'">
        			<SysOnt:userPassword>'.$_SESSION['swint_password']
				.'</SysOnt:userPassword>
        			<foaf:mbox rdf:resource="mailto:'.$_SESSION['swint_email'].'" />
    				</foaf:Agent>
					</rdf:RDF>';

				$type="rdf";
				$uri=OW_CONFIG;
				try{
					$this->loadToModel(utf8_encode($str), $type, $uri, $store);
				}
				catch(Exception $e){
					echo get_class($e) . ': ' . $e->getMessage();
				}
			}
			//reset sw user password, in order to adjust the change of user registration data in sw  
			else {
				$model = $store->getModel(OW_CONFIG);
				$sub   = OW_CONFIG.$_SESSION['swint_user'];
				$pred  = 'http://ns.ontowiki.net/SysOnt/userPassword';
				//$statement = new Statement(new Resource($sub), new Resource($pred), NULL);
				$model->remove($model->findFirstMatchingStatement(new Resource($sub), new Resource($pred), NULL));
				$model->add(new Statement(new Resource($sub), new Resource($pred), new Literal($_SESSION['swint_password'])));


}


			// --- user take the admin rights for some advantage actions
/*
			if(1){
				$str='<?xml version="1.0" encoding="UTF-8" ?>
						<!DOCTYPE rdf:RDF [
    					<!ENTITY SysOnt "http://ns.ontowiki.net/SysOnt/">
    					<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    					<!ENTITY foaf "http://xmlns.com/foaf/0.1/">
    					<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    					<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
					]>
					<rdf:RDF xml:base="'.OW_CONFIG.'"
  					xmlns:SysOnt="&SysOnt;"
  					xmlns:rdf="&rdf;"
  					xmlns:foaf="&foaf;"
  					xmlns:rdfs="&rdfs;">
 
 					<foaf:Group rdf:about="http://localhost/OntoWiki/Config/AdminGroup">
      					<foaf:member rdf:resource="'.$_SESSION['swint_user'].'" />
  					</foaf:Group>
  					
  				</rdf:RDF>';

				$type="rdf";
				$uri=OW_CONFIG;
				try{
					$this->loadToModel(utf8_encode($str), $type, $uri, $store);
				}
				catch(Exception $e){
					echo get_class($e) . ': ' . $e->getMessage();
				}
			}
			*/

			if(1){
				$model = $store->getModel(OW_CONFIG);
				$sub   = OW_CONFIG.'AdminGroup';
				$pred  = 'http://xmlns.com/foaf/0.1/member';
				$obj   = OW_CONFIG.$_SESSION['swint_user'];
				$statement = new Statement(new Resource($sub), new Resource($pred), new Resource($obj));
				$model->add($statement);
				
			}

			// --- login, now change the sw identity
			try{
				$this->_erfurtApp->authenticate($_SESSION['swint_user'], $_SESSION['swint_password']);

			}
			catch(Exception $e){
				echo get_class($e) . ': ' . $e->getMessage();
			} 
			

			// --- check the existence of group
			$isGroupFound=false;
			$sparql = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/>
				PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>				
				SELECT ?label           
           		WHERE { ?s rdf:type foaf:Group .  ?s rdfs:label ?label }';

			$grouplist=$store->executeSparql($store->getModel(OW_CONFIG), $sparql, null, 'xml');
			if(strpos($grouplist, '<binding name="label"><literal>'.$_SESSION['swint_projectid'].'</literal>')>0)
			$isGroupFound=true;


			if(!$isGroupFound){
				$str='<?xml version="1.0" encoding="UTF-8" ?>
						<!DOCTYPE rdf:RDF [
    					<!ENTITY SysOnt "http://ns.ontowiki.net/SysOnt/">
    					<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    					<!ENTITY foaf "http://xmlns.com/foaf/0.1/">
    					<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    					<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
					]>
					<rdf:RDF xml:base="'.OW_CONFIG.'"
  					xmlns:SysOnt="&SysOnt;"
  					xmlns:rdf="&rdf;"
  					xmlns:foaf="&foaf;"
  					xmlns:rdfs="&rdfs;">
 
     			    <foaf:Group rdf:about="'.OW_CONFIG.$_SESSION['swint_projectid'].'"
      					rdfs:label="'.$_SESSION['swint_projectid'].'">
					<SysOnt:denyAccess rdf:resource="&SysOnt;AnyAction" />
        				<SysOnt:grantAccess rdf:resource="&SysOnt;Login" />

        				<SysOnt:grantModelView rdf:resource="&SysOnt;AnyModel" />
<SysOnt:denyAccess rdf:resource="&SysOnt;SoftWikiUseOntoWiki" />
        				<SysOnt:denyModelView rdf:resource="'.OW_CONFIG.'" />
						<SysOnt:denyModelView rdf:resource="&SysOnt;" />
						<SysOnt:grantModelEdit rdf:resource="'.$projuri.'" />
        
        				<rdfs:comment>This auto-configured '.$_SESSION['swint_projectid'] .' user group can only edit own model but read all models.</rdfs:comment>
               		</foaf:Group>
               		
  					
  				</rdf:RDF>';

				$type="rdf";
				$uri=OW_CONFIG;
				try{
					$this->loadToModel(utf8_encode($str), $type, $uri, $store);
				}
				catch(Exception $e){
					echo get_class($e) . ': ' . $e->getMessage();
				}
			}

			// --- check the existence of membership
			$isMember=false;
			$sparql = 'PREFIX foaf: <http://xmlns.com/foaf/0.1/>
				PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
				PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>			
				SELECT ?member           
           		WHERE { ?s rdf:type foaf:Group .  ?s foaf:member ?memberuri .
           				?memberuri foaf:nick ?member  
						?s rdfs:label "'.$_SESSION['swint_projectid'].'"}';

			$memberlist=$store->executeSparql($store->getModel(OW_CONFIG), $sparql, null, 'xml');
			if(strpos($memberlist, '<binding name="member"><literal>'.$_SESSION['swint_user'].'</literal>')>0)
			$isMember=true;

			if(!$isMember){
				$str='<?xml version="1.0" encoding="UTF-8" ?>
						<!DOCTYPE rdf:RDF [
    					<!ENTITY SysOnt "http://ns.ontowiki.net/SysOnt/">
    					<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    					<!ENTITY foaf "http://xmlns.com/foaf/0.1/">
    					<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    					<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
					]>
					<rdf:RDF xml:base="'.OW_CONFIG.'"
  					xmlns:SysOnt="&SysOnt;"
  					xmlns:rdf="&rdf;"
  					xmlns:foaf="&foaf;"
  					xmlns:rdfs="&rdfs;">
 
 					<foaf:Group rdf:about="'.$_SESSION['swint_projectid'].'">
      					<foaf:member rdf:resource="'.$_SESSION['swint_user'].'" />
  					</foaf:Group>	
  					
  				</rdf:RDF>';

				$type="rdf";
				$uri=OW_CONFIG;
				try{
					$this->loadToModel(utf8_encode($str), $type, $uri, $store);
				}
				catch(Exception $e){
					echo get_class($e) . ': ' . $e->getMessage();
				}
			}

/*
			// --- check the existence of project model
			$empty_project_model_rdf='<?xml version="1.0" encoding="UTF-8" ?>
					<!DOCTYPE rdf:RDF [
				    	<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    					<!ENTITY owl "http://www.w3.org/2002/07/owl#">
    					<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    					<!ENTITY req "http://ns.softwiki.de/req/">
    					<!ENTITY skos "http://www.w3.org/2004/02/skos/core#">
    					<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
    				]>

					<rdf:RDF xml:base="'.$projuri.'"
  						xmlns:rdf="&rdf;"
  						xmlns:owl="&owl;"
  						xmlns:rdfs="&rdfs;"
  						xmlns:req="&req;"
  						xmlns:skos="&skos;">
					
  					<owl:Ontology rdf:about="'.$projuri.'">
        				<rdfs:label>'.$_SESSION['swint_projectid'].': '.str_replace('"', '&quot;', str_replace('&', '&amp;', strip_tags($_SESSION['swint_title']))).'</rdfs:label>
        				<rdfs:comment>'.str_replace('"', '&quot;', str_replace('&', '&amp;', strip_tags($_SESSION['swint_title']))).'</rdfs:comment>
					<rdfs:comment>'.$_SESSION['swint_projectid'].' Project</rdfs:comment>        	
					<owl:imports rdf:resource="http://www.w3.org/2004/02/skos/core" />
        				<owl:imports rdf:resource="http://www.holygoat.co.uk/owl/redwood/0.1/tags/" />
        				<owl:imports rdf:resource="&req;" />
    				</owl:Ontology>'
				.'<skos:Concept rdf:about="Concept1.1">
        				<skos:prefLabel>Grundlegende und bergreifende Anforderungen</skos:prefLabel>
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.2"
      					skos:prefLabel="Informationsbeschaffung" />

    				<skos:Concept rdf:about="Concept1.2.1"
      					skos:prefLabel="Suche">
        				<skos:broader rdf:resource="Concept1.2" />
    				</skos:Concept>

				    <skos:Concept rdf:about="Concept1.2.2"
      					skos:prefLabel="Personalisierung">
        				<skos:broader rdf:resource="Concept1.2" />
    				</skos:Concept>

				    <skos:Concept rdf:about="Concept1.2.3"
      					skos:prefLabel="Standorte">
        				<skos:broader rdf:resource="Concept1.2" />
    				</skos:Concept>

				    <skos:Concept rdf:about="Concept1.3"
     					skos:prefLabel="Zusammenarbeiten und Wissenssicherung" />

    				<skos:Concept rdf:about="Concept1.3.1"
      					skos:prefLabel="Mitarbeiter/Skills">
        				<skos:broader rdf:resource="Concept1.3" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.3.2"
      					skos:prefLabel="Kunden">
        				<skos:broader rdf:resource="Concept1.3" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.3.3"
      					skos:prefLabel="Projekte">
        			<skos:broader rdf:resource="Concept1.3" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.3.4"
      					skos:prefLabel="Werkzeuguntersttzung">
        				<skos:broader rdf:resource="Concept1.3" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.4"
      					skos:prefLabel="Prozessintegration" />

    				<skos:Concept rdf:about="Concept1.4.1"
      					skos:prefLabel="Planungshilfe">
        					<skos:broader rdf:resource="Concept1.4" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.4.2"
      					skos:prefLabel="Prozesse">
        				<skos:broader rdf:resource="Concept1.4" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.5"
      					skos:prefLabel="Socialising" />

    				<skos:Concept rdf:about="Concept1.5.1"
      					skos:prefLabel="Social Networking">
        				<skos:broader rdf:resource="Concept1.5" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.5.2"
      					skos:prefLabel="Kommunikation">
        				<skos:broader rdf:resource="Concept1.5" />
    				</skos:Concept>

    				<skos:Concept rdf:about="Concept1.7"
      					skos:prefLabel="Sonstiges" />

    				<skos:Concept rdf:about="Concept1.6"
      					skos:prefLabel="Benutzerfreundlichkeit" />
				</rdf:RDF>';

			$type="rdf";
			$uri=$projuri;
			if($store->modelExists($uri)){
				if($store->getModel($uri)===false){
					$store->deleteModel($uri);
					try{
						$this->loadToNewModel(utf8_encode($empty_project_model_rdf), $type, $uri, $store);
					}
					catch(Exception $e){
						echo get_class($e) . ': ' . $e->getMessage();
					}
				}
			}
			else{
				try{
					$this->loadToNewModel(utf8_encode($empty_project_model_rdf), $type, $uri, $store);
					
				}
				catch(Exception $e){
					echo get_class($e) . ': ' . $e->getMessage();
				}
			}
//!!!!!!!!!!!!!ILLOGICAL anyway!!!!!!!!!!!!!!!!!!
			$this->_config->activeModel = $store->getModel($uri);

			// --- check the existence of reqs
			if(sizeof($_SESSION['swint_reqlist'])>0){
				$sparql = 'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
				PREFIX req: <http://ns.softwiki.de/req/>			
				PREFIX dc: <http://purl.org/dc/elements/1.1/>
				SELECT ?s           
           		WHERE { ?s rdf:type req:Requirement }';

				$urilist=$store->executeSparql($store->getModel($projuri), $sparql, null, 'xml');
				if(strpos($urilist, '<binding name="s"><uri>'.$_SESSION['swint_modelbaseuri'])>0){
					#var_dump($urilist);
					$doImport=false;
				}
				else $doImport=true;
				if($doImport){
					$count = 0;
					$str='<?xml version="1.0" encoding="UTF-8" ?>
					<!DOCTYPE rdf:RDF [
    				<!ENTITY rdf "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
    				<!ENTITY req "http://ns.softwiki.de/req/">
    				<!ENTITY dc "http://purl.org/dc/elements/1.1/">
   				 	<!ENTITY dcterms "http://purl.org/dc/terms/">
    				<!ENTITY skos "http://www.w3.org/2004/02/skos/core#">
    				<!ENTITY rdfs "http://www.w3.org/2000/01/rdf-schema#">
    				<!ENTITY xsd "http://www.w3.org/2001/XMLSchema#">
					]>

					<rdf:RDF xml:base=""
  					xmlns:rdf="&rdf;"
  					xmlns:req="&req;"
  					xmlns:dc="&dc;"
  					xmlns:dcterms="&dcterms;"
  					xmlns:skos="&skos;"
  					xmlns:rdfs="&rdfs;">				
				';
					foreach($_SESSION['swint_reqlist'] as $req){
						$count++;
						$str = $str
						. '<req:Requirement rdf:about="'.$projuri.'Req'.$count.'"
      					dc:title="'.
						utf8_encode(str_replace('"', '&quot;', str_replace('&', '&amp;', strip_tags($req['title'])))).
						'"
      					dc:description="&lt;p&gt;'.
						utf8_encode(str_replace('"', '&quot;', str_replace('&', '&amp;', strip_tags($req['description'])))).

      					'&lt;/p&gt;">
        				<skos:primarySubject rdf:resource="'.$projuri.'Concept1.7" />
        				<req:isDefinedBy rdf:resource="http://localhost/OntoWiki/Config/'.$_SESSION['swint_user'].'" />
    					</req:Requirement>
						';				
					}
					$str = $str . '</rdf:RDF>';
					$type="rdf";
					$uri=$projuri;
					try{
						$this->loadToModel($str, $type, $uri, $store);
					}
					catch(Exception $e){
						echo get_class($e) . ': ' . $e->getMessage();
					}
				}
			}


			// --- user gives the admin rights back
			if(1){
				$model = $store->getModel(OW_CONFIG);
				$sub   = OW_CONFIG.'AdminGroup';
				$pred  = 'http://xmlns.com/foaf/0.1/member';
				$obj   = OW_CONFIG.$_SESSION['swint_user'];
				$statement = new Statement(new Resource($sub), new Resource($pred), new Resource($obj));
				$model->remove($statement);
				
			}

*/
			// --- logout, login once again/authenticate
			try{
				{
				$auth->clearIdentity();
				$this->_erfurtApp->authenticate($_SESSION['swint_user'], $_SESSION['swint_password']);
				$this->isIntegrated=true;

				}
			}
			catch(Exception $e){
				echo get_class($e) . ': ' . $e->getMessage();
			}


		
		}
		return true;
	}


	public function addCofundosWindow(&$str)
	{
		$auth = Zend_Auth::getInstance();
		$identity = $auth->getIdentity();
		
		$content = '<div>'
		//. '<img style="margin:0.5em; display:block; margin-left:auto; margin-right:auto;" src="'
		//.  $this->_config->uriBase . 'plugins/Cofundos/cf-logo.png"/>'
		. '<h4 style="text-align:center;">' . $this->_strings->swint->common->description . '</h4>'
		. '</div>';

		$content = $content 
		. '<div>'
		. 'Hello You\'re<br/><p class="messagebox info">SoftWiki\'s User --- '. $identity['username']
		. '</p></div>';

		$content = $content 
		. '<div>'
		. '<p class="messagebox info">'.$_SESSION['swint_projectid'].'\'s User --- '. $_SESSION['swint_user']
		. '</p></div>';


		if($this->isIntegrated===true)
		{
			$content = $content 
			. '<div>'
			. '<p class="clearfloat messagebox success">You\'re integrated.</p>'
			. '</div>';
		}
		else{
			$content = $content 
			. '<div>'
			. '<p class="messagebox warning">You\'re NOT integrated.'
			. '</p></div>';

		}

		if($this->_config->activeModel){
			$content = $content 
			. '<div>'
			. '<p class="messagebox info">current '.$_SESSION['swint_projectid'].' project --- '.$this->_config->activeModel->getBaseURI()
			. '</p></div>';
			
			if (1) {

			//get the editable cofundos projects
			$store = Zend_Registry::get('erfurt')->getStore();
			$sparql = 'PREFIX owl: <http://www.w3.org/2002/07/owl#>
				PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>	
				PREFIX foaf: <http://xmlns.com/foaf/0.1/>				
				SELECT distinct ?group ?proj        
           			WHERE { ?group rdf:type foaf:Group .  ?group rdfs:label ?label .  ?group rdfs:comment '
				.'"This auto-configured '.$_SESSION['swint_projectid'].' user group can only edit own model but read all models."'
				.' . ?group foaf:member <'.OW_CONFIG.$identity['username'].'> . ?group <http://ns.ontowiki.net/SysOnt/grantModelEdit> '
				.'?proj .} ';

			$urilabellist=$store->executeSparql($store->getModel(OW_CONFIG), $sparql, null, 'xml');
			//var_dump($urilabellist);
			$xml = new SimpleXMLElement($urilabellist);
			$content .= '<form class="row-input"><p class="no-min-width">'
				. '<label class="onlyAural" for="mainselection">'.$_SESSION['swint_projectid'].' Project Selection</label>'
				. '<select name="mainselection" id="mainselection" size="1" onChange="go(this)" class="width99" >'
				. '<option value="">' . '--- Select a avaiable '.$_SESSION['swint_projectid'].' project ---' 
				. '<option selected="selected" value="">' . '--- (editable) '
				. ' ------------------------------------' 
				. '</option>';	
			foreach($xml->results->result as $urilabel){
				$nr=substr($urilabel->binding[0]->uri, strlen('http://localhost/OntoWiki/Config/cfUserGroup'));
				$q = 'PREFIX owl: <http://www.w3.org/2002/07/owl#>
				PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>	
				PREFIX foaf: <http://xmlns.com/foaf/0.1/>				
				SELECT ?projlabel
				WHERE { ?proj rdf:type owl:Ontology .  ?proj rdfs:label ?projlabel . ?proj rdfs:comment "'.$_SESSION['swint_projectid'].' Project" .
					filter (sameTERM(STR(?proj), "'.$urilabel->binding[1]->uri.'"))}';
				$l=$store->executeSparql(NULL, $q, null, 'xml');
				$x = new SimpleXMLElement($l);
				//var_dump($l);
				foreach($x->results->result as $y){
					$content .= '<option style="background-color:#CCFFCC" '
					. 'value="' .$this->_config->uriBase
					. 'resource/list/?r=http://ns.softwiki.de/req/Requirement&m='.$_SESSION['swint_modelbaseuri'].$nr.'/">'
					. $y->binding[0]->literal.'</option>';
				}
			}



				//get the avaiable cofundos projects(readable) 			
			$sparql = 'PREFIX owl: <http://www.w3.org/2002/07/owl#>
				PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>	
				PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>			
				SELECT distinct ?cfproj ?label          
           			WHERE { ?cfproj rdf:type owl:Ontology .  ?cfproj rdfs:label ?label . ?cfproj rdfs:comment "'.$_SESSION['swint_projectid'].' Project" }';

			$urilabellist=$store->executeSparql(null, $sparql, null, 'xml');
			$xml = new SimpleXMLElement($urilabellist);
					
			$content .= '<option value="">' . '--- (readable) '
				. ' ------------------------------------' 
				. '</option>';			

			foreach($xml->results->result as $urilabel){
					$content .= '<option style="background-color:#FFFFCC" '
					. 'value="' .$this->_config->uriBase
					. 'resource/list/?r=http://ns.softwiki.de/req/Requirement&m='.$urilabel->binding[0]->uri.'">'
					. $urilabel->binding[1]->literal.'</option>';
			}
			$content .= '</select></p>';

			}
		}

//if(isset($_SESSION['swint_return']) && isset($_SESSION['swint_old_projectid'])){
		if(isset($_SESSION['swint_return'])){
			$content = $content
			. '<p>'
			. '<a href="'. $_SESSION['swint_return'].'" class="button" title="'
			. $this->_strings->swint->returntooltip . '">'
			. $this->_strings->swint->return . '</a></p>';
		}

		$content .= '</form>';
		$newWindow = array('cssId'=>'cfMainselectionbox', 'cssClasses' => 'is-minimized',
				'title'=>$this->_strings->swint->mainselect->title,
				'content'=>$content
		);

		$str .= $this->_view->partial('micro/window.php', $newWindow);
		
		return true;
	}
	
	
	
	
	
	public function grabActions() {

		// get front controller
		$frontController = Zend_Controller_Front::getInstance();

		// get request object
		$request = $frontController->getRequest();

		// save controller and action names
		$controller = $request->getControllerName();
		$action     = $request->getActionName();


	}



	public function loadToModel($str, $type, $uri, $store) {
		$model = $store->getModel($uri);
		$memmodel = new MemModel();
		try{
			$memmodel->loadFromString($str, $type);
			$model->addModel($memmodel);
		}
		catch(Exception $e){
			echo get_class($e) . ': ' . $e->getMessage();
		}
	}


	public function loadToNewModel($str, $type, $uri, $store) {
		$model = $store->getNewModel($uri, $uri);
		$memmodel = new MemModel();
		try{
			$memmodel->loadFromString($str, $type);
			$model->addModel($memmodel);
		}
		catch(Exception $e){
			echo get_class($e) . ': ' . $e->getMessage();
		}
	}


}


?>
