<?php

/**
  * OntoWiki Main Layout Template
  *
  * @author Norman Heino
  * @author Michael Haschke
  * @version $Id$
  * @license GPL
  */

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<?php echo $this->processEvent('header_start') ?>

<?php echo $this->headTitle() ?>
<meta http-equiv="content-type" content="text/html; charset=<?php echo $this->charset; ?>" />

<script type="text/javascript">
//<![CDATA[
	/* TODO: remove if no old widgets left */
	var erfurtUriBase   = '<?php echo $this->erfurtUriBase . 'lib/'; ?>';
	var erfurtPublicUri = '<?php echo $this->erfurtPublicUri; ?>';
	var owUriBase       = '<?php echo $this->owUriBase; ?>';
	var owThemeBase     = '<?php echo $this->themeBase; ?>';
	var inlineEditing   = <?php echo $this->inlineEditingEnabled ? 'true' : 'false' ?>;
	var showNews        = <?php echo $this->showNews ? 'true' : 'false' ?>;
//]]>
</script>

<!-- improvements on speed: Javascript imports moved to body bottom -->

<!-- ontowiki stylesheets -->
<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/old.css" />
<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/default.css" />
<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/clickmenu.css" />

<!-- IE conditional stylesheets -->
<!--[if lte IE 6]><link rel="stylesheet" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/default.ie6.css" /><![endif]-->
<!--[if lte IE 6]><link rel="stylesheet" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/clickmenu.msie.css" /><![endif]-->
<!--[if IE 7]><link rel="stylesheet" media="screen" href="<?php echo $this->escape($this->themeBase) ?>styles/default.ie7.css" /><![endif]-->

<?php if (!empty($this->stylesheets)): ?>
<!-- widget styles -->
<?php foreach ($this->stylesheets as $stylesheet): ?>
<link rel="stylesheet" type="text/css" href="<?php echo $stylesheet ?>" />
<?php endforeach; ?>
<?php endif; ?>

<?php if (!empty($this->onLoadRegistry)): ?>
<!-- JSONized onload registry -->
<script type="text/javascript">
//<![CDATA[
var onLoadJson = [
<?php $n = 0; ?>
<?php foreach ($this->onLoadRegistry as $code): ?>
	<?php echo '"' . $code . '"' . (++$n != count($this->onLoadRegistry) ? ', ' : '') . PHP_EOL ?>
<?php endforeach; ?>
];
//]]>
</script>
<?php endif; ?>

<?php echo $this->headScript() ?>

<?php echo $this->processEvent('header_end') ?>

</head>

<body class="javascript-off">
<script type="text/javascript">
    // test for javascript
    document.getElementsByTagName("body")[0].className = "javascript-on is-processing";
</script>

<div class="section-mainwindows"><!-- Section 1 -->

<?php echo $this->partial('partials/mainwindow.php') ?>

<?php echo $this->processEvent('plugin_example_directoutput') ?>

<?php echo $this->processEvent('maincontent_end') ?>

</div><!-- Section 1 -->

<div class="section-sidewindows"><!-- Section 2 -->
	<?php echo $this->processEvent('sidecontent_start') ?>
	
	<?php echo $this->placeHolder('sidebar') ?>
	
	<?php echo $this->partial('micro/window.php', $this->processEvent('plugin_example_data')) ?>
			
	<?php echo $this->processEvent('sidecontent_end') ?>
</div><!-- Section 2 -->

<div id="overlays"></div>

<?php echo $this->processEvent('footer_start') ?>

<!-- Start - Javascript Includes -->

    <!-- Prototype -->
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/prototype.js"></script>

    <!-- Scriptaculous -->
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/scriptaculous.js"></script>

    <!-- jQuery -->
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/jquery.js"></script>
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/jquery.livequery.js"></script>
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/jquery.clickmenu.js"></script>
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/jquery.ui.js"></script>

    <!-- RDF API-JS -->
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/lib/rdfapi-js/Model.js"></script>

    <!-- ontowiki scripts -->
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/old.js"></script>
    <script type="text/javascript" src="<?php echo $this->escape($this->themeBase) ?>scripts/index.js"></script>
    <script type="text/javascript" src="<?php echo $this->escape($this->erfurtUriBase) ?>lib/powlapi/scripts.js"></script>

    <!-- widget scripts -->
    <?php if (isset($this->scripts)): ?>
        <?php foreach ($this->scripts as $script): ?>
            <script type="text/javascript" src="<?php echo $script ?>"></script>
        <?php endforeach; ?>
    <?php endif; ?>

<!-- End - Javascript Includes -->

<?php echo $this->processEvent('footer_end') ?>

</body>
</html>
